/* sqw-afix.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Simple internal AREAFIX  module.   ⮩  	஥  AREAFIX'a.
 * Isn't required for DOS and  OS/2    ॡ  ᪮  /2 ᨩ,
 * versions - SQAFIX by Pete Kvitek   ⠪  譨 SQAFIX, ᠭ  ⮬
 * is much better. UNIX version  of   ⥪,  .     ᪮
 * sqafix isn't ready yet, and I am   ᮢ  sqafix'a   㤥
 * writing this code for UNIX...      -      UNIX.
 *
 * Main logic of this module is:      ᭮  ࠡ ⮣ :
 *
 * We analyse lines of message seq-    㥬 ப ᮮ饭 ᫥-
 * uentially.  If  command  in line   ⥫쭮. ᫨    ﭨ
 * changes subscription status,  we   ᪨, 塞 ﭨ 䫠 ALIC.
 * set bit flag ALIC.
 *
 * If changes are needed, file des-   ᫨ 㦭 ,  २뢠  
 * cribed in line SquishCfg, is re-   ⠥ 䠩, ᠭ  ப SquishCfg
 * named. Then it is read, and only   ᫥⥫쭮.    ப
 * EchoArea lines are taken from it   EchoArea.
 * to be changed, if needed.
 *
 * Rebuild  EchoArea line from it's   ᮡࠥ ப EchoArea  
 * keys and from (ALIS ^ ALIC).        祩   ⮢ (ALIS ^ ALIC).
 */

#include "./sqw-inc.h"

int Sqw_afix_update(void);
static void Sqw_afix_notupdate(int);

#if AREAFIX_STYLE

#include "./_skips.c"

int Sqw_afix(unsigned int, unsigned int);

static int linkcmp(const void *, const void *);
static void msg_answer_begin(void);
static void msg_answer_file(char *, char *, char *);
static void msg_answer_part(void);
static void msg_answer_end(void);

#define next_token(s0,s1) { *s1 = c; skipspace(s1); s0 = s1; skipword(s1); c = *s1; *s1 = '\0'; }

/* ============================================================================
 *
 * Receives message number and link   砥  ᮮ饭     .
 * number. Assumes filepkt is  ope-   ࠧ㬥,   ਯ	filepkt
 * ned, and fseek is setted to	the     ⥭,  fseek  ⠭  
 * beginning  of  message.  Assumes    砫 ᮮ饭. ⨩ ࠬ  -
 * third parameter to be  used	for     樨   -
 * netmail packet filename  genera-    .
 * tion.
 *
 * Returns num of written messages.   頥 ᫮ ᠭ ᮮ饭.
 *
 * Assumes fileout to be  open  for   ࠧ㬥     ⮪  fileout
 * writing.                            .
 *
 * ------------------------------------------------------------------------- */

static unsigned int msgs, _link, _msgnum;
static unsigned long bytes;

int Sqw_afix ( unsigned int msgnum, unsigned int link)
{
char tmpline[MAXPATH+2];
unsigned long offkeep = ftell(filepkt);
unsigned long offset = ftell(filepkt) + (sizeof(mh))
	+ Msg[msgnum].LTo + Msg[msgnum].LFrom +
	+ Msg[msgnum].LSubj;
unsigned long length = Msg[msgnum].Length - offset + offkeep;
unsigned long area_off;
unsigned int  arnum, is_query;

char *s0 = Buffer;
char *s1, *s2;
unsigned int	i,j, c;

int tabAL[] = { WBD_AF_UNLINK,	WBD_AF_ACTIVE,	WBD_AF_WO_UNLINK,
		WBD_AF_WO,	WBD_AF_RO_UNLINK,	WBD_AF_RO,
		WBD_AF_UNLINK,	WBD_AF_ACTIVE	};

/**Debug("offset = %lu", offset);**/

bytes = 0;
msgs = 0;
_link = link;
_msgnum = msgnum;

fseek(filepkt, offset, SEEK_SET);
fread(Buffer, (size_t)length, 1, filepkt);	/* Size checking is in Sqw_pr */

msg_answer_begin();

if (_link == 0)			/* It's not our link (address in Link[0] is */
   {				/* originating address of message           */
   fputs(wbd[WBD_AF_NOLINK], fileout);
   fputc('\r', fileout);
   msg_answer_end();
   return 1;
   }
else;

while(*s0 && ((int)(s0 - Buffer) < (int)length))
    {
    switch (*s0++)
	{
	case '\r': case '\n': continue;
	case '\0': s0--; continue;
	case '\1': s0[-1] = '@';
	case '\t': case ' ': while (!IsCfgEOL(*s0)) s0++;  continue;
	}
    s0--;
    s1 = s0;
    skipword(s1);
    c = *s1;
    *s1 = '\0';
    switch(*s0++)
	{
	case '%':
	 switch(toupper(*s0))
	   {
	   case 'H':
		if (!stricmp(s0,"HELP"))
		   {
/* %HELP [lan] line ------------------------------------------------------- */
		   next_token(s0,s1);
		   if ((s1-s0) < 3) s0 = Link[_link].Lang; else;
		   sprintf(tmpline,Format_s3s_s, Config, s0, hlp_cfg);
		   msg_answer_file(tmpline, wbd[WBD_AF_NOHELP], s0);
		   }
		else goto Wrong_AF_Command;
		break;
	   case 'R':
		if (!stricmp(s0,"RULES"))
		   {
/* %RULES <area> line ----------------------------------------------------- */
		   char *tmpath;
		   next_token(s0,s1);
		   if (*s0)
		     if ((tmpath = Path_Tag(s0,(unsigned int)(s1-s0))) != NULL)
			{
			sprintf(tmpline, Format_s_s, tmpath, Rul);
			msg_answer_file(tmpline, s0, wbd[WBD_AF_NORULES]);
			} /* if (tmpath) */
		     else bytes += fprintf (fileout, Format_ss,s0,wbd[WBD_AF_NOAREA]);
		   else	{
/* %RULES of all subscribed areas not implemented yet - - - - - - - - - - - */
			}
		   } /* if RULES */
		else goto Wrong_AF_Command;
		break;
	   case 'Q':
		if (!stricmp(s0,"QUERY")) goto QueLst;
		else goto Wrong_AF_Command;
/*		break; */
	   case 'L':
		if (!stricmp(s0,"LANGUAGE"))
		   {
		   next_token(s0,s1);
		   if (*s0 == '?')
			{
			struct ffblk f;
			sprintf(tmpline,Format_s3s_s, Config, "???", hlp_cfg);
			fputs(wbd[WBD_AF_LANGLIST], fileout);
			if (!findfirst(tmpline,&f,0))
			   do	if (f.ff_fsize &&
				    ((f.ff_fsize>>10) < MAXCFGSIZE))
				   fprintf(fileout,Format__3s, f.ff_name);
				else;
			   while (!findnext(&f));
			else fputs(wbd[WBD_AF_EMPTYLIST], fileout);
			bytes += 80;
			fputc('\r', fileout);
			} /* if (*s0 == '?') in LANGUAGE */
		   else {
/**** Temporarily switching language is available **********/
			s2 = Link[_link].Lang;
			*s2++ = *s0++; *s2++ = *s0++; *s2++ = *s0++;
/**** Constant Switch languages is not implemented yet *****/
			}
		   } /* if LANGUAGE */
		else
		 if (!stricmp(s0,"LIST"))
		   {
QueLst:
		   is_query = (toupper(*s0) == 'Q');
		   s2 = (char *)Tag_Lin;
		   area_off = _link + (AREA1ST * Link_Num);
		   fprintf (fileout, Format_sr, wbd[WBD_AF_LHEADER]);
		   for (i = AREA1ST; i < (unsigned int)Area_Num; i++)
			{
			j = AreaLink[area_off];
			if (j & ALIC) j ^= ALIS; else;
			if ((!is_query) || (j & ALIS))
			   bytes += fprintf (fileout,"%-60.*s %s\r",
					Area[i].Tag, s2, wbd[tabAL[7 & j]]);
			else;
			s2 += Area[i].Tag;
			area_off += Link_Num;
			msg_answer_part();
			} /* for i < Area_Num */
		   } /* if (!stricmp(s0,"LIST")) */
		else goto Wrong_AF_Command;
		break;
	   default:
Wrong_AF_Command: fprintf (fileout, "%%%s - %s\r", s0, wbd[WBD_AF_NOCOMMAND]);
		break;
	   } /* switch(toupper(*s0)) */
		break;
	case '-':
		if ((*s0 == '-') && (s0[1] == '-')) goto Out_While; else;
	case '+': s0++;                 /* subscribe to echo */
	default:  s0--;
		arnum = Find_Tag(s0, (unsigned int)(s1-s0));
		if (arnum)
			{
			area_off = _link + (arnum * Link_Num);
			j = AreaLink[area_off];
			if (j & ALIC) j ^= ALIS; else;
			if (((!(j & ALIS)) && (s0[-1] == '-')) ||
			    ((j & ALIS) && (s0[-1] != '-')))
			      bytes += fprintf(fileout, "%-60s %s %s\r",
				s0, wbd[WBD_ALREADY], wbd[tabAL[7 & j]]);
			else  {
			      j ^= ALIC;
			      bytes += fprintf(fileout, "%-60s %s\r",
					s0, wbd[tabAL[7 & (j ^ ALIS)]]);
			      AreaLink[area_off] = (char)j;
			      }
			} /* if arnum */
		else	{
			fprintf (fileout, "%-65s %s\r", s0, wbd[WBD_AF_NOAREA]);
			}
		break;
	} /* switch (*s0++) */
    *s1 = (char)c;
    s0 = s1;
    while (!IsCfgEOL(*s0)) s0++;
    } /* while (*s0) */

Out_While:
msg_answer_end();
fseek(filepkt, offkeep, SEEK_SET);

return msgs;
} /* Sqw_afix(); */

/* ---------------------------------------------------------------------------
 * Begins AREAFIX  answer  message.   稭 ⢥ AREAFIX'a.
 * ------------------------------------------------------------------------- */

static void msg_answer_begin()
{

#if DEBUG
/** Debug part - control of right our address found as dMy **/
int arorig = Msg[_msgnum].dMy;
if ((Msg[_msgnum].dZone	!= My[arorig].Zone) ||
    (Msg[_msgnum].dNet	!= My[arorig].Net) ||
    (Msg[_msgnum].dNode	!= My[arorig].Node) ||
    (Msg[_msgnum].dPoint != My[arorig].Point))
    {
Debug("Control Msg[%i].dMy = %i", _msgnum, arorig);
Debug("Msg[%i].d... address is %u:%u/%u.%u", _msgnum,
      Msg[_msgnum].dZone,Msg[_msgnum].dNet,Msg[_msgnum].dNode,Msg[_msgnum].dPoint);
Debug("My[%i] address is %u:%u/%u.%u", arorig,
      My[arorig].Zone, My[arorig].Net, My[arorig].Node, My[arorig].Point);
    }
else;
#endif

msg_netmail_begin(_link, Msg[_msgnum].dMy,
	"AREAFIX", "SysOp", "Remote request Operation report");
msgs++;
} /* msg_answer_begin() */

/* ---------------------------------------------------------------------------
 * Finishes AREAFIX answer message.   蠥 ⢥ AREAFIX'a
 * ------------------------------------------------------------------------- */

static void msg_answer_end()
{
fprintf(fileout, Format_sr, wbd[WBD_AF_LTXTORG]);/* Text of original message:*/
fprintf(fileout, Format_s, Buffer);             /* text itself (invalidated) */
if (msg_netmail_end(wbd[WBD_AF_LFOOTER], "AREAFIX answer"))
    { /* Progress-bar */
    sprintf(Buffer,"; Answering %hu:%hu/%hu.%hu; %.3s",
	Link[_link].Zone, Link[_link].Net, Link[_link].Node, Link[_link].Point,
	Link[_link].Lang);
    printf (Format_sn, Buffer);
    OutLog2(LEV_WARN, Area_Desc[AREAFIX], Buffer);
    }
} /* msg_answer_end() */

#endif /* AREAFIX_STYLE */

/* ---------------------------------------------------------------------------
 * Writes new squish.cfg if needed.     squish.cfg, ᫨ 㦭.
 * Called from main().		      뢠  main().
 *
 * Returns:			      頥:
 * 0 - nothing done (not necessary)   祣  ᤥ,   ॡ.
 * 1 - new config written.	       䨣 ᠭ.
 * 2 - new config NOT written, old     䨣  ᠭ,  ࠭
 *     is kept as is. errno.	       . ⠭ errno.
 * 3 - new config is dramatically      䨣  祭 ᨫ쭮  
 *     shortened or  truncated in       ࠢ   䠩, 
 *     comparison  with old file.        .  䠩	᪮-
 *     Old file is kept in .###.      ஢  .###  ࠭.
 * 4 - No config found. 	      䨣 ᪨  .
 * ------------------------------------------------------------------------- */

int Sqw_afix_update()
{

int is_update;
#if AREAFIX_STYLE
unsigned long area_off = AREA1ST*(unsigned long)Link_Num;
unsigned int  arnum = AREA1ST;
unsigned int  link;
ADDR	addr;			/* ⥫   ᪨	    */
int	here_addr;		/*   ⥪ ⨫ ?	    */
register unsigned int i,j;
#endif

/***************** Check if update is needed *********************************/
is_update = ((Cfg_NewAreasCreate == 2) && (New != NULL));

#if AREAFIX_STYLE
while (arnum < Area_Num)
      {
      link = 0;
      while(++link <= Link_Num)
	{
	j = AreaLink[++area_off] & ALIC;
	if (j)	{
		is_update = 1;
		Link[link].Update = 1;
		Area[arnum].Update = 1;
		}
	else;
	}
      arnum++;
      } /* while (arnum < Area_Num) */
#endif /* AREAFIX_STYLE */

if (!is_update) return 0; else;

/**************** Check previous possible crashes of config *****************/

/**************** Open input and output files *******************************/
filepkt = fopen(squish_cfg,rt);
if (filepkt == NULL)
   {
   OutLog2(LEV_LOOSE,squish_cfg,Read_Error);
   Sqw_afix_notupdate(WBD_NO_SQUISHCFG);
   return 4;
   }
else;
fileout = fopen(squish_xfg,wt);
if (fileout == NULL)
   {
   OutLog2(LEV_LOOSE,squish_xfg,Write_Error);
   Sqw_afix_notupdate(WBD_WE_SQUISHCFG);
   return 2;
   }
else;
if (Cfg_BufSize != BUFSIZ)
	{
	setvbuf(filepkt, Buf_Pkt, _IOFBF, Cfg_BufSize);
	setvbuf(fileout, Buf_Out, _IOFBF, Cfg_BufSize);
	}
else;
/**************** AutoCreate areas process **********************************/
if ((Cfg_NewAreasCreate == 2) && (New != NULL))
   {
   char Format_EchoArea_Added[] = "EchoArea %s %s %s %hu:%hu/%hu.%hu %s\n";
   NEW	huge *new = New;
   unsigned int link, result, area;
   char *s0;
   while(new)
	{
	link = new->Link;
	s0 = (char *)Path_Lin;
	result = 0;
	do {
	   sprintf(Buffer, Format_s8lx, NewAreaPath, ++ttt);
	   result = 0;
	   for (area = 0; area < Area_Num; area++)
		{
		if (!Fname_cmp(s0,Buffer)) { result = 1; break; } else;
		s0 += Area[area].Path;
		}
	   }
	while (result && ttt);

	fprintf(fileout,Format_EchoArea_Added,
		new->Line, Buffer, NewAreaFlags,
		Link[link].Zone, Link[link].Net,
		Link[link].Node, Link[link].Point, NewAreaNodes);
	new = new->Next;
	} /* while(new) */
/**/fprintf(fileout,"; Above Areas AutoAdded %s", ctime(&ttt));
   } /* if (Cfg_NewAreasCreate == 2) && (New != NULL)) */
else;

#if AREAFIX_STYLE
/**************** Sort link table *******************************************/
Link[0].Zone = Link[0].Net = Link[0].Node = Link[0].Point = Link[0].domain =0;
for (link = 0; link <= Link_Num; link++)
	Link_Tab[link] = link;
qsort ((int *)Link_Tab, Link_Num+1, sizeof(int), linkcmp);
/**************** Read input and write output file **************************/

/* ============ Loop of read/write ======================================= */

while (fgets(Buffer,MINSEENBY,filepkt))
 {
   char *s0 = Buffer, *s2,
	*s1 = s0, c, c1;		/* 㪠⥫  பx  ᨬ    */

 if (*s0 == '#') goto Write_Line; else;
 endline(s1);
 if (s1 == Buffer) goto Write_Line; else;/* ᫨  ப ⮫쪮   */
 c1 = *s1;
 *s1 = '\0';                            /*   ப ( ) */
 skipword(s0);
 c = *s0;	     /*  ᨬ ᫥ 祢 ᫮  c	   */
 *s0 = '\0';         /* ⬥  祢 ᫮ 㫥 ⮬      */
 if (stricmp(Buffer,keywords[Key_EchoArea]))
	{		/*  ப EchoArea ॣ塞 " 뫨"        */
	*s0 = c;
	*s1 = c1;
	goto Write_Line;
	}
 else;
 *s0 = c;			/* ⠭ ᨬ ᫥ .᫮      */
 skipspace(s0); 		/* s0 㪠뢠  砫 ⠣	     */
 s2 = s0;
 skipword(s2);			/* s2 -   ⠣		     */
 c = *s2;
 *s2 = '\0';
 arnum = Find_Tag(s0, (unsigned int)(s2-s0));
 if ((arnum > Area_Num) || (arnum < AREA1ST))
	OutLog2(LEV_LOOSE, s0, " - unknown areatag found in SquishCFG");
 else;
 *s2 = c;
 *s1 = c1;
 if ((arnum > Area_Num) || (arnum < AREA1ST) || (!Area[arnum].Update))
	goto Write_Line;
 else;

 addr.Zone   = Lin->Zone   = My->Zone;
 addr.Net    = Lin->Net    = My->Net;
 addr.Node   = Lin->Node   = My->Node;
 addr.Point  = Lin->Point  = My->Point;
 addr.domain = Lin->domain = My->domain;

 s1 = s2;
 skipspace(s1); skipword(s1);	/* s1 -     㯮	     */
 c = *s1;
 *s1 = '\0';
 fprintf(fileout, Format_s, Buffer);	/* 뢥 砫 ப  䠩      */
 *s1 = c;
  s0 = s1;			/* s0 ⥯  砫 祩		     */

/* -------------------- Loop of EchoArea line analysis --------------------- *
 * As in Sqw_cr2(), read items from      Sqw_cr2(),    ப  
 * line. Rewrite all non-links keys   .  -   ப
 * from the line w/o changes. Then,   ९뢠     .	⥬,
 * after all keys, link  subscripts   ᫥  祩,   -
 * are added from ALIS^ALIC bits.      ᪨  ⮢ ALIS^ALIC.
 *
 * Note!			      !
 *
 * If link is between other keys  -   ᫨    㣨 砬
 * it changes Lin by cr_padr(), and   -   Lin १ cr_padr(),	  
 * this change must be detected (by      祭 ࠢ-
 * comparison, and  addresses  here   ,        	
 * items  are  to be rewritten. For    ⪮४஢. ਬ:
 * example:
 *
 * was before:
 * -p122 7:1130/5 -x/7
 *
 * must become:
 * -p122 -x7:1130/7 5
 *
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
 while ((here_addr=cr_padr (&s0)) != HERE_EOL)
	{			/*    ப 	   */
	switch (here_addr)
		{
		case HERE_LINK: break;

		case HERE_X:
		case HERE_P:
		case HERE_PLUS:
		case HERE_MINUSU:
			if ((addr.Zone	 != Lin->Zone) ||
			    (addr.Net	 != Lin->Net) ||
			    (addr.Node	 != Lin->Node) ||
			    (addr.Point  != Lin->Point) ||
			    (addr.domain != Lin->domain))
			    { /* full address */
			    s2 = s1;
			    skipspace(s2);
			    while (!isdigit(*s2)) *s2++;
			    fprintf (fileout, "%.*s%hu:%hu/%hu",
				(unsigned int)(s2-s1), s1,
				Lin->Zone, Lin->Net, Lin->Node);
			    if (Lin->Point) fprintf (fileout,".%hu",
				Lin->Point); else;
			    }
			else {
			     s2 = s1; skipspace(s2); skipword(s2);
			     fprintf(fileout, "%.*s",
				(unsigned int)(s2-s1), s1);
			     }
			addr.Zone   = Lin->Zone;
			addr.Net    = Lin->Net;
			addr.Node   = Lin->Node;
			addr.Point  = Lin->Point;
			addr.domain = Lin->domain;

			break;
		case HERE_NOADDR:
		default: s2 = s1; skipspace(s2); skipword(s2);
			fprintf (fileout, "%.*s", (unsigned int)(s2-s1), s1);
			 break;
		} /* switch(here_addr) */
	s1 = s0;
	} /* while (HERE_EOL...) */
/******************  ᪨ *******************************************
 * To  this  moment  addr  contains    ⮬  	addr  ᮤন	⥪饥
 * current status of address,  ana-   ﭨ 㥬  ப  Echo-
 * lysed from EchoArea line identi-   Area ,  ᫨   ⠫ 䨣
 * cally to config reading process.   㭪ﬨ Sqw_cr?().
 *
 */

 area_off = (unsigned long)arnum * Link_Num;
 for (link = 0; link <= Link_Num; link++)
	{
	i = Link_Tab[link]; if (i == 0) continue; else;
	j = AreaLink[area_off + i];
	if (j & ALIC) j ^= ALIS; else;
	if (j & ALIS)
		{
		fputc(' ', fileout);
		if (Link[i].domain != addr.domain)
		   if (Link[i].Point)
			fprintf(fileout, Format_5DP,
				Link[i].Zone, Link[i].Net, Link[i].Node,
				Link[i].Point, Dmn[Link[i].domain].name);
		   else fprintf(fileout, Format_5D,
				Link[i].Zone, Link[i].Net, Link[i].Node,
				Dmn[Link[i].domain].name);
		else	{
			if (Link[i].Zone != addr.Zone)
			   fprintf(fileout, "%hu:%hu/%hu",
				Link[i].Zone, Link[i].Net, Link[i].Node);
			else if (Link[i].Net != addr.Net)
				fprintf(fileout, net_node,
					Link[i].Net, Link[i].Node);
			     else if (Link[i].Node != addr.Node)
					fprintf(fileout,"%hu", Link[i].Node);
				  else if (Link[i].Point == addr.Point)
					{
/*
 * This condiiton means,  that	two   室    ᫮ 砥, 
 * links  with	identical addresses    ⠡     
 * exists in our link table.  It IS   묨 ᠬ.   -  ᮬ
 * some error  in  algorythm. Maybe   訡 -   ⬠.    -
 * some  'wild  pointer'  reference    뫪 १  " 㪠⥫"
 * crashed link table...	      㫠 ⠡ .
 */
sprintf(Buffer,Format_5DP, Link[i].Zone, Link[i].Net, Link[i].Node,
			   Link[i].Point, Dmn[Link[i].domain].name);
OutLog2(LEV_ABORT,Buffer, "- two copies in Link table");
Errexit(Lin_CrashLink,Erl_Tag_Lin);
					};

			if (Link[i].Point)
			   fprintf(fileout, ".%hu", Link[i].Point);
			else;
			} /* else Link[i].domain != addr.domain */
		addr.Zone   = Link[i].Zone;
		addr.Net    = Link[i].Net;
		addr.Node   = Link[i].Node;
		addr.Point  = Link[i].Point;
		addr.domain = Link[i].domain;
		}/* if (j & ALIS) */
	else;
	} /* for link */
 fputc('\n', fileout);
 continue;
Write_Line: fputs(Buffer, fileout);
 } /* while (fgets()) */
#endif /* AREAFIX_STYLE */
/**************** Final checking for errors/crashes *************************/
if (ferror(filepkt)) OutLog2(LEV_LOOSE, squish_cfg, Read_Error); else;
fclose(filepkt);
if (ferror(fileout)) OutLog2(LEV_LOOSE, squish_xfg, Write_Error); else;
fclose(fileout);
return 0;
} /* int Sqw_afix_update() */

/* -------------------------------------------------------------------------
 * Report  to all links  subscribed   頥 ᥬ 뢠訬/⯨뢠-
 * or  unsubscribed, that operation   訬 ,     뫠  -
 * was not successfull. 	      譮.
 * ------------------------------------------------------------------------ */

static void Sqw_afix_notupdate(int reason)
{
unsigned int i;
char *s = wbd[reason];

for (i = 1; i <= Link_Num; i++)
    if (Link[i].Update)
	{
/**/	printf ("\n%s\n", s);
/***** Not implemented yet */
/**/	OutLog (LEV_POSSIBLE,"Sqw_afix_notupdate() isn't implemented yet");
/**/	OutLog (LEV_POSSIBLE,"No messages be sent to links about errors");
	}
    else;
} /* static void Sqw_afix_notupdate(int reason) */

#if AREAFIX_STYLE
/*************** 㭪 ࠢ Link  qsort() ***********************/
/*------------------------------------------------------------------------*/
static int linkcmp(const void *ii, const void *jj)
{
int *i = (int *)ii;
int *j = (int *)jj;

if (Link[*i].domain == Link[*j].domain)
   if (Link[*i].Zone == Link[*j].Zone)
      if (Link[*i].Net == Link[*j].Net)
	 if (Link[*i].Node == Link[*j].Node)
	    if (Link[*i].Point == Link[*j].Point) return 0;
	    else if (Link[*i].Point > Link[*j].Point) return 1;
		 else return -1;
	 else if (Link[*i].Node > Link[*j].Node) return 1;
	      else return -1;
      else if (Link[*i].Net > Link[*j].Net) return 1;
	   else return -1;
   else if (Link[*i].Zone > Link[*j].Zone) return 1;
	else return -1;
else if (Link[*i].domain > Link[*j].domain) return 1;
     else return -1;
} /* linkcmp() */

/* ------------------------------------------------------------------------- *
 * Reads file and writes it to  out
 * stream fileout  with  converting
 * EOL to message EOL '\r'.
 *
 * Destroys string in first param!
 * ------------------------------------------------------------------------- */

void msg_answer_file(char *tmpline, char *line1, char *line2)
{
struct stat f;
FILE *fileadd;
char *s0;

fileadd = fopen(tmpline,rt);

if (fileadd)
   {
/*
 * Check if file is long enough  to   ஢, ᫨  䠩 筮 ,
 * be divided by the  next boundary   ⮡       ᫥饩
 * given by  MaxMsgPartLength - set   ࠭楩  ᮮ饭ﬨ,  -
 * the boundary to end current mes-   ᨬ ࠧ஬    ᮮ饭  -
 * sage immediately.                  ⠢ ᮮ饭  ᥩ.
 *
 */
   if (Cfg_MaxMsgPartLength && (!stat(tmpline,&f)))
    if (f.st_size > ((Cfg_MaxMsgPartLength<<10) - bytes))
      bytes = ((Cfg_MaxMsgPartLength + 1)<<10);
    else;
   else;
   
   while(fgets(tmpline,MAXPATH,fileadd))
     {
     msg_answer_part();
     s0 = tmpline;
     while(*s0)
          {
          if (*s0 == '\r') *s0 = ' '; else;  /* Strip 'Mac' EOL   */
          if (*s0 == '\n') *s0 = ' '; else;  /* Strip 'unix' EOL  */
#if SOFTCR_TO_H
          if (*s0 == 0x8D) *s0 = 'H'; else;  /* Russian '' -> 'H' */
#endif
          s0++;
          }
     bytes += fprintf(fileout, Format_sr, tmpline);	/* add 0D as EOL */
     }
   fclose(fileadd);
   }
else bytes += fprintf (fileout, Format_ss, line1,line2);
fputc('\r',fileout);
} /* void msg_answer_file */

/* ======================================================================== *
 * If bytes  written to the message   ᫨ ࠧ ᠭ ᮮ饭 ॢ-
 * reaches value of maximum message   ᨫ ᨬ쭮 ࠧ   ᮮ-
 * part length - divide message.       - ࠧ ᮮ饭  .
 * ------------------------------------------------------------------------ */

void msg_answer_part()
{
if (Cfg_MaxMsgPartLength && ((bytes>>10) >= Cfg_MaxMsgPartLength))
   {
   fputs(wbd[WBD_CONTINUENEXT], fileout);
   fputc('\r', fileout);
   fprintf(fileout, sVersion, rTear,		/* tearline */
	SQW_VERTYPE, SQW_VERSION, SQW_SUBVERS, your_compiler);
   fputc('\r', fileout);                /* End of message            */
   fputc('\0', fileout);                /* Last zero byte of message */
   msg_answer_begin();
   fputs(wbd[WBD_FROMPREVIOUS], fileout);
   fputc('\r', fileout);
   bytes = 20;
   }
else;
}

#endif /* AREAFIX_STYLE */
