/* sqw-cr.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Config parsing subroutines.	      ணࠬ  䨣.
 *
 */

#include "./sqw-inc.h"
#include "./_skips.c"

unsigned long Sqw_cr1(void);
	 void Sqw_cr2(void);
	 void Sqw_cr3(void);
	 void Sqw_cr4(void);

/* ============================================================================
4 parts of config parser.	      4   䨣.
**----------------------------- ६   -------------------*/
unsigned int ln = -1;	/* 稪 ப 䨣			     */
static	char Error_Directive[] = "Error directive at line %u: %s\n";
/*----------------------------- 㭪樨     ------------*/
static char *Next_Line(void);
static int cr_addr_cmp(ADDR huge *, ADDR huge *);

#if INCLUDE

/*----------------------------- ⥭ । ப  Buffer ------------*/
static unsigned char Stack_ptr=0;	/* ⥫ ⥪ include	     */
static unsigned long Offsets[MAXDEPTH]; /* ⢥ ⥪ Include	     */

static char *Next_Line(void)
{
char *result_fgets;			/* १ ⥭ ப  䠩  */
unsigned long Ltmp;

result_fgets = fgets(Buffer,MAXLEN,filepkt);
while (result_fgets == NULL)		/* 㯨 end of current file      */
	   {
	   if (Stack_ptr == 0) return 0;	/* end of sqwish_cfg	     */
	   else {				/* end of included file      */
		Stack_ptr--;			/* stack pointer up	     */
		filepkt = freopen(PKTFile[Stack_ptr],rb,filepkt);
		if (filepkt == NULL)
		   {
		   sprintf(Buffer,"Error reopen file %s when returned from included %s",
			PKTFile[Stack_ptr], PKTFile[Stack_ptr+1]);
		   OutLog(LEV_ABORT,Buffer);
		   Errexit(Lin_Error,Erl_Syntax);
		   }
		else free(PKTFile[Stack_ptr+1]);/* free name space	*/
		fseek(filepkt, Offsets[Stack_ptr], SEEK_SET);
		result_fgets = fgets(Buffer,MAXLEN,filepkt);
		} /* else Stack_ptr == 0 */
	   } /* while result_fgets == NULL */
Offsets[Stack_ptr] = ftell(filepkt);		/* next position in cur file */
if ((!strcasecmp_match (Buffer, "Include*")) ||
    (!strcasecmp_match (Buffer, "Application*sqwish*Include*"))
   )
   { char *s1 = Buffer; 		/* Enter included file */
     char *s0, c;
   if (Stack_ptr++ >= (MAXDEPTH - 1))
	Errexit ("Maximum Include Depth reached!", Erl_Syntax);
   else;
   if (toupper(*s1) == 'A')
	{
	skipchar(s1);				/* skip word Application     */
	skipspace(s1);
	skipchar(s1);				/* skip word sqwish	     */
	skipspace(s1);
	}
   else;
   skipchar(s1);				/* skip word Include	     */
   skipspace(s1);				/* skip spaces after it      */
   s0 = s1;
   endline(s0);
   c = *s0;
   *s0 = '\0';                                  /* pathname - between s1/s0  */
   fclose(filepkt);				/* close previous file	     */
   filepkt = fopen(s1,rb);
   if (filepkt == NULL)
	{
	sprintf(Buffer,"In file %s line Include %s - Can't open include file",
			PKTFile[Stack_ptr-1], s1);
	OutLog(LEV_ABORT, Buffer);
	Errexit(Buffer, Erl_Config);
	}
   else;
   Ltmp = strlen(s1) + 2;
   AllocCheck(Ltmp, PKTFile[Stack_ptr]);
   strcpy(PKTFile[Stack_ptr], s1);
   *s0 = c;
   } /* if strcasecmp_match(Buffer, "Include*") */
else;
return Buffer;
} /* Next_Line() */
#else	/* INCLUDE */
					  /* It is old variant - w/o Include */
#define Next_Line() fgets(Buffer,MAXLEN,filepkt)
#endif	/* INCLUDE */

/* ᫨ 䨪  襩  -  ᪨ 䨪 */
char *skip_os(char *s0)
{
char *s1 = s0, c;
skipword(s1);
c = *s1; *s1 = '\0';
if (stricmp(your_os, s0) == 0) { *s1 = c; skipspace(s1); return s1; }
else { *s1 = c; return s0; }
}

/*----------------------------- ࠢ  ᮢ ----------------------*/
static int cr_addr_cmp (ADDR huge *AAA, ADDR huge *BBB)
{return ((AAA->Zone == BBB->Zone) && (AAA->Net	 == BBB->Net) &&
	 (AAA->Node == BBB->Node) && (AAA->Point == BBB->Point) &&
	 (AAA->domain == BBB->domain)
	);
}
#define cr_addr_cmp(A,B) cr_addr_cmp((ADDR huge *)A,(ADDR huge *)B)
/*-----------------------------  ࠡ⪨ ⠡  ---------------
If current link number is not zero,   ᫨  ⥪饣  -  , 
set parameter A for it in status B;   ⠭ ࠬ A    	  B;
If current link number is zero, set   ᫨  ⥪饣   ࠢ  -
parameter A for ALL links in B.        ⠭ A    B    .

Identical for echoareas.	      筮  宮⥩.

Note,  that executed code simplifi-   ⨬,  饭  ᯮ塞 
cation caused me to set some  parts   ॡ    ࠬ஢
in structures Area and Link identi-   - ⥩  - ६  -
cal, and  some	of  these parts are    Area  Link,      ᯮ-
not used at all.		      짮.
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */
#define LASet(A,B) Link[Link_Now].A=B; Area[Area_Now].A=B;\
 if (!Link_Now) {register unsigned int i; for (i=0;i<=Link_Num;i++)Link[i].A=B;} else;\
 if (!Area_Now) {register unsigned int i; for (i=0;i<=Area_Num;i++)Area[i].A=B;} else

/*************** First pass of config reading ********************************
 * Counts  config  lines'  number,    뢠 ᫮ ப  䨣, -
 * sets BufSize and SysLog options    ⠭ ࠬ  BufSize,  SysLog,
 * and analyses LogFile option.        ப LogFile.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

unsigned long Sqw_cr1()
{
unsigned long lin_Num = 0;
rewind (filepkt);			/* ⬮ 䠩  砫 */

#if INCLUDE
PKTFile[0] = sqwish_cfg;		/* ᫨  - 室 䠩 */
#endif

ln = -1;
while ((Next_Line()) != NULL)
	{
/*+###046*/
	char *s0 = Buffer, *s1;
	s1 = s0 = skip_os(Buffer);		/* ய 䨪 ᢮  */
	skipword(s0); skipspace(s0);
	if (!strcasecmp_match (s1, "BufSize*"))
		Cfg_BufSize = atoi(s0);
	else;
	if (!strcasecmp_match (s1, "UseSyslog*"))
		Cfg_UseSyslog = 1;
	else;
	if (!(Cfg_UseSyslog) && (!strcasecmp_match (s1, "LogFile*")))
		{
		if (tossing_log) farfree(tossing_log); else;
		s1 = s0;
		skipword(s1);
		*s1 = '\0';
		AllocCpy(tossing_log);
		}
	else;
/*-###046*/
	lin_Num++;
	}
return lin_Num;
} /* Sqw_cr1() */

/*
 * Batch* lines analysis.	       ப Batch*
 */

void Batch_Line (char **s0, char **s1, char **batch, char **line, char *c)
{
AllocCheck(((*s1-*s0)+1),*batch);
strcpy(*batch,*s0);
**s1=*c;
skipspace(*s1);
*c = *((*s1)++);
if (isgraph(*c))
   {
   AllocCheck((strlen(*s1)+3), *line);
   *s0 = *line;
   }
else;
if (isgraph(*c))
   while ((**s1 != *c) && (**s1 != '\r')
		  && (**s1 != '\n') && (**s1 != '\0')) *((*s0)++) = *((*s1)++);
else;
*((*s0)++) = ' ';
*((*s0)++) = '\0';
} /* Batch_Line() */

/*
 * NewArea* lines analysis	       ப NewArea*...
 * Simplest. Skips = options.         ⥩訩.  樨 =.
 */

void NewArea_Line (char **s0, char **s1, char **line, char *c)
{
if (*line) return; else;
**s1 = *c;
if (**s0 == '=')
   {
/**  Not implemented yet **/
   skipword(*s0);
   skipspace(*s0);
   *s1 = *s0;
   }
else;
endline(*s1);
*c = **s1;
**s1 = '\0';
AllocCheck((((*s1)-(*s0))+2), *line);
strcpy(*line,*s0);
**s1 = *c;
}

/*********************** Second pass ******************************************
Counts: 			      뢠:
number of echoareas;		      ᫮ 宮⥩
summary length of echotags;	      㬬  ப ⠣
Number of links (creates table);      ᫮  (ᮧ ⠡)
number of my own addresses;	      ᫮ ᮡ⢥ ᮢ ⥬

Sets global config parameters.	      ⠭  ࠬ.
---------------------------------------------------------------------------- */
void Sqw_cr2()
{
ADDR	huge *addr = Lin;	/* ⥫  		    */
int	here_addr;		/*   ⥪ ⨫ ?	    */
int	cnt_keywnotf = 0;	/* 稪  祢 ᫮	    */

ln = -1;
/**Debug("Second Pass");*/
/* ----------- 室 樠 ६  䨣 ------- */
Tag_Sum = 0; Tag_Len = 0; Twit_Sum = 0; Twit_Num = 0; Inb_Len = 0;
Link_Num = 0;  My_Addr_Num = 0;  Area_Num = AREA1ST;  Path_Sum = 0;
Cfg_MaxCommandLength = MAXCMDLEN;
rewind (filepkt);

Cfg_Before = 1;

/* ============ Loop of Second pass ====================================== */
while ((Next_Line()) != NULL)
 {
   int	keywnum,			/*  ᪮ 祢 ᫮  */
	keywnotf;			/* 祢 ᫮  	   */
   char *s0 = Buffer,
	*s1 = s0, c;			/* 㪠⥫  பx  ᨬ    */
   time_t ttx;				/* ६  ப Before	   */

 ln++;
 Line[ln].Hash = 0;
 Line[ln].offsm = 0;		/*###033*/
 if (*s0 == '#') continue;      /* ###043   砫 ப - ਩ */
 endline(s1);
 if ((*s1 == '\r') && (s1[1] != '\n'))
    {
    printf (sqwish_cfg_line_n, ln);
    Errexit("0D without 0A encountered.",Erl_Syntax);
    }
 else;
 *s1 = '\0';                            /*   ப ( ) */
 if (s1 == Buffer) continue; else;/* ᫨  ப ⮫쪮   */
 s1 = Buffer;

Our_Application_Keyword:		/*	<-------+*/	/* ###049 */
					/*		|*/
 s0 = s1 = skip_os(s1); 		/*		|*/
 Line[ln].Hash = 0;			/*		|*/
 while ((*s0 <= 'z') && (*s0 >= 'A'))   /*              |*/
	Line[ln].Hash = HASH_ADD(Line[ln].Hash,*s0++);/*|*/
 if (s0 == Buffer) continue; else;	/*		|*/
 c = *s0;	     /*  ᨬ ᫥ 祢 ᫮  c	   */
 *s0 = '\0';         /* ⬥  祢 ᫮ 㫥 ⮬      */
/** Debug("Buffer = >%s<", Buffer); */
 keywnum=0;			/* C稪  ஢塞 ࠧ	   */
 keywnotf=1;			/*  ࠢ ப		   */
 while (keywnotf && (keywnum < Cfg_Verbs_Num))	/*	|*/
	if (Line[ln].Hash == keyhashes[keywnum++]) keywnotf = 0;
 keywnum--;				/*		|*/
/* 諨 室騩  - 㡥, ᮢ  ப|		   */
 if ((keywnotf) || stricmp(s1, keywords[keywnum]))    /*|	   ###049  */
    {					/*		|*/
    if (cnt_keywnotf++ == 0) printf("Unknown words in config line(s):"); else;
    printf(" %i",ln+1);                 /*              |*/
    Line[ln].Hash = 0;			/*		|*/
    continue;			/* ᫨ ᫮   -       */
    }					/*		|*/
 else;				/* ᫨ ᫮  - ஢ ப */
 *s0 = c;			/* ⠭ ᨬ ᫥ .᫮      */
 skipspace(s0); 		/* s0 㪠뢠  砫 ᫥饣 ᪠   */
 s1 = s0;				/*		|*/
 skipword(s1);			/* s1 -   ᫥饣 ᪠	     */
 c = *s1;			/*  ᫥騩 ᨬ		     */
 *s1 = '\0';                    /*     - 㫥              */
 Line[ln].offsm = (char)(s0 - Buffer);
						/*	|*/
 if (Line[ln].Hash == HASH_Application) 	/*	|*/
    {						/*	|*/
    if	(!strcasecmp_match("sqwish", s0))       /*      | sqwish    */
	{					/*	|  㪠   */
	*s1 = c;				/*	| ਫ - -  */
	skipspace(s1);				/*	| 㥬 ⮪   */
	s0 = s1;				/*	| ப  . */
	goto Our_Application_Keyword;/* some lines up---+*/
	}
    else continue;			/* Application  㣨 	*/
    }
 else;					/*-###049	*/

/* V03.04+ */ if (Line[ln].Hash == HASH_EndBefore) Cfg_Before = 1; else;
/* V03.04+ */ if (!Cfg_Before) { Line[ln].Hash = 0; continue; } else;
 switch (Line[ln].Hash)
  {
  case HASH_Error:
  	    *s1 = c;
  	    printf(Error_Directive, ln, s0);
  	    break;
/* V03.04+ */
  case	HASH_Before:		/*  ப   ࠢ  ⥪饩*/
	   if ((ttx = Date_From_Line(s0)) == 0L)
		Errexit ("Invalid Date in Before line", Erl_Syntax);
	   else	{
		Line[ln].Hash = 0;
		if (ttt < ttx) Cfg_Before = 1; else Cfg_Before = 0;
		}
	   break;
/* V03.04- */

  case	HASH_Address:		/*   ⮬ ⮫쪮    */
	   *s1 = c;		/* ⠪     稭 */
	   if (My_Addr_Num == 0)/*  㣨 ᮢ   ப	   */
		{
		Lin = My;
		if (Sqw_adr((char **)&s0) == 0)
		   Errexit(Wrong_Address, Erl_Syntax);
		else;
		Lin = addr;
		}
	   else;		/*  ⠥ ⢮ ᮢ	   */
	   My_Addr_Num++;
	   break;

  case	HASH_EchoArea:			/* ப 宮⥩		   */
	   Area_Num++;
	   Tag_Sum += (s1-s0)+1;	/*   ⠣ 	   */
	   if (Tag_Len < (unsigned char)(s1-s0))
	       Tag_Len = (unsigned char)(s1-s0); else;
	   *s1=c;
	   skipspace(s1);
	   s0 = s1;
	   skipword(s1);		/* ய  		   */
	   Path_Sum += (s1-s0)+1;	/*    - ᫨ DupeFile */
	   c = *s1;

  case	HASH_Pack:			/*  娢஢ -   */
					/* 㪠  		   */
	   s0 = s1;
  case	HASH_Node:
  case	HASH_TinySeenBys:
  case	HASH_ZoneGate:
  case	HASH_AddToSeen:
  case	HASH_Password:
  case	HASH_StartLink:

	   *s1 = c;
	   Lin->Zone   = My->Zone;
	   Lin->Net    = My->Net;
	   Lin->Node   = My->Node;
	   Lin->Point  = My->Point;
	   Lin->domain = My->domain;

	   while ((here_addr=cr_padr (&s0)) != HERE_EOL)
		{			/*    ப 	   */
		register int i = Link_Num;
		if ((here_addr == HERE_P) || (here_addr == HERE_NOADDR))
		    continue; else;
		if (Link_Num != 0) /*  ᮢ饣       */
		   while (cr_addr_cmp(&(addr[i]),Lin) == 0) i--;
		else;
		if (i == 0) /* the same address not found */
			{
			Link_Num++; i = Link_Num;
			addr[i].Zone  = Lin->Zone;
			addr[i].Net   = Lin->Net;
			addr[i].Node  = Lin->Node;
			addr[i].Point = Lin->Point;
			addr[i].domain = Lin->domain;
/**	printf (" ln=%i; Link_Num = %i; ", ln, Link_Num);
	printf ("Lin = %u:%u/%u.%u@%i\n", Lin->Zone, Lin->Net, Lin->Node, Lin->Point, Lin->domain);
**/
			if (Link_Num >= MAXLINK)
				{
	printf ("Link Number exceeded MAXLINK = %i; Recompilation needed.\n", Link_Num);
	Errexit (Lin_Memory, Erl_Memory);
				}
			}
		else;
	    if ((Line[ln].Hash == HASH_Password) ||
		(Line[ln].Hash == HASH_Node) ||
		(Line[ln].Hash == HASH_StartLink)) break; else;
		} /* while here_addr != HERE_EOL */
	   break;
  case	HASH_DefaultPacker: if (strlen(s0) < 9) strcpy(Def_Pack,s0); else; break;
  case	HASH_NetFile: AllocPath(s0,&InBound, LENNAME + LENEXT + 3, &Inb_Len); break;
  case	HASH_OutBound: AllocPath(s0,&OutPath, LENNAME + LENEXT + 3, &Out_Len); break;
  case	HASH_DirFlags:	AllocPath(s0,&FlagD, LENNAME + LENEXT + 3, &Flg_Len); break;
  case	HASH_DirConfig:  AllocPath(s0,&Config, LENNAME + LENEXT + 3, &Cfg_Len); break;
  case	HASH_OutBink:  AllocPath(s0,&BinkPath, MAXADDPATH, &BinkLen); break;
  case	HASH_Hold:  AllocPath(s0,&HoldPath, MAXADDPATH, &HoldLen); break;

  case	HASH_RescanCommand: AllocCpy(call_rescan); break;
  case	HASH_Compress:	AllocCpy(compress_cfg); break;
  case	HASH_SquishCFG:  AllocCpy(squish_cfg); break;

  case	HASH_BatchCreate: Batch_Line(&s0,&s1, (char **)&sqwacr_bat, (char **)&sqafix_create, &c); break;
  case	HASH_BatchArc: Batch_Line(&s0, &s1, (char **)&sqwash_bat, (char **)&call_sqwarc, &c); break;

  case	HASH_NewAreaPath: NewArea_Line(&s0, &s1, (char **)&NewAreaPath, &c); break;
  case	HASH_NewAreaFlags: NewArea_Line(&s0, &s1, (char **)&NewAreaFlags, &c); break;
  case	HASH_NewAreaNodes: NewArea_Line(&s0, &s1, (char **)&NewAreaNodes, &c); break;
  case	HASH_NewAreaRefuse: NewArea_Line(&s0, &s1, (char **)&NewAreaRefuse, &c); break;

  case	HASH_Duplicates:

#if !DUPETABLE
	Cfg[keywnum] = atoi(s0);
	if (Cfg_Duplicates == 0)
	   Errexit ("No Table Checking - Duplicates must be != 0", Erl_Syntax);
	else;
	break;
#endif /* DUPETABLE */

  case	HASH_LogLevel:	  case	HASH_CacheSize:   case	HASH_SecureNotRename:
  case	HASH_CheckDate:   case	HASH_CorrectDate: case	HASH_PointSecure:
  case	HASH_DupeCheck:case	HASH_DirCheckFast:
  case	HASH_TearLineExist:			  case	HASH_PathLoop:
  case	HASH_TossAfterZeroes:			  case	HASH_DupeFile:
  case	HASH_HexadecimalNamesPKT:		  case	HASH_CheckSplit:
  case	HASH_TruncSent: 			  case	HASH_RegExp:
  case	HASH_MinUUEline: case  HASH_OutNames:	  case	HASH_ArcShield:
  case	HASH_RulesParts: case  HASH_RulesExtract: case	HASH_NewAreasCreate:
  case	HASH_MaxCommandLength:			  case	HASH_MaxMemoryUsage:
  case	HASH_CheckFields:
#ifdef Cfg_MaxMsgPartLength
  case	HASH_MaxMsgPartLength:
#endif

	Cfg[keywnum] = atoi(s0); break;

  case	HASH_Secure:	   case HASH_NetDupes:	case	HASH_KillNetDupes:
  case	HASH_NonSecureMinusU:			case	HASH_TwitNetMail:
  case	HASH_ClearorigPoint:			case	HASH_ArcMailAttach:
  case	HASH_ZoneGateDefault:			case	HASH_TruncWeek:
  case	HASH_OutFileLowerCase:			case	HASH_BadArea:
  case	HASH_DupeArea:

	Cfg[keywnum] = 1; break;

#if ((AREAFIX_STYLE & 1) || (AREAFIX_IN_ECHOES))
  case HASH_Alias:	   case HASH_IgnoreMsgsFrom:
#endif

  case HASH_RulesFrom:	   case HASH_RulesTo:	  case HASH_RulesSubj:

  case HASH_TwitFrom:	   case HASH_NoTwitFrom:  case HASH_TwitSubj:
  case HASH_NoTwitSubj:    case HASH_TwitTo:	  case HASH_NoTwitTo:
  case HASH_TwitKludge:    case HASH_NoTwitKludge:
  case HASH_TwitAddr:	   case HASH_NoTwitAddr:
	{ unsigned char delimiter = ' ';
	   *s1=c;
	   Twit_Num++;
#if ((AREAFIX_STYLE & 1) || (AREAFIX_IN_ECHOES))
	if ((Line[ln].Hash != HASH_Alias) &&
	    (Line[ln].Hash != HASH_IgnoreMsgsFrom))
	   {
#endif
	s1 = s0+1;
	if (isgraph(*s0)) delimiter = *s0; else;
#if ((AREAFIX_STYLE & 1) || (AREAFIX_IN_ECHOES))
	   }
	else s1 = s0;
#endif
	      while ((*s1 != delimiter) && (!IsCfgEOL(*s1))) s1++;
	   Twit_Sum += (s1-s0) + (delimiter == ' ') ;
	} /* char delimiter */
	   break;

  default: break;
  } /* switch (Line[ln].Hash) */
 } /* while Next_Line - second pass loop */
if (cnt_keywnotf != 0) puts(""); else;
} /* Sqw_cr2() */

/******************************************************************************
Fills My address tables.	       ⠡ ᮡ⢥ ᮢ.
Fills Link tables.		       ⠡ .
Fills Area echoarea table, Tag_Lin.    ⠡ ⥩, ப ⠣
Fills subscription tables Area??.      ⮢ ⠡窨 ᪨.
******************************************************************************/
void Sqw_cr3()
{
int	here_addr, here_mask0, here_mask1;
int	my = 0; 	/* 稪 ᮢ				   */
unsigned int	ar;		/* 稪 宮⥩			   */

/**Debug("Third Pass");*/
ln = -1;
rewind (filepkt);

Tag_Sum = 0;
Path_Sum = 0;
for (ar = AREANET; ar < AREA1ST; ar++) Area[ar].Tag = Area[ar].Org = 0;
for (ar = AREANET; ar < AREA1ST; ar++) Area[ar].Path = 0;
ar = AREA1ST;
/*************** Loop of Third pass *****************************************/
while ((Next_Line()) != NULL)
 {
 char	*s0, *s1, c;

 ln++; s0 = s1 = Buffer + Line[ln].offsm;
 skipword(s1);			/* s1 -   ᫥饣 ᪠	   */
 c = *s1;			/*  ᫥騩 ᨬ		   */
 *s1 = '\0';                    /*     - 㫥            */
 switch (Line[ln].Hash)
  {
  case	HASH_Address:
	   *s1 = c;
	   Lin = (ADDR *)(&My[my]);
	   Sqw_adr ((char **)&s0);
	   my++;
	   break;
  case	HASH_EchoArea:
	   Area[ar].Tag = (char)(strlen(s0)+1); /*  x⠣	   */
	   strcpy((char *)(Tag_Lin+Tag_Sum),s0);
					/*  x⠣ ७  Tag_Lin*/
	   Tag_Sum += Area[ar].Tag;	/* 稢 㬬ୠ    */
	   Area[ar].Org = 0;		/*  㬮砭  -     */
	   Area[ar].killDupes = 0;
	   Area[ar].flavor = 0;
#if (AREAFIX_STYLE)
	   Area[ar].Update = 0;
#endif

	   Lin = (ADDR *)(&Link[0]);
	   Lin->Zone   = My->Zone;
	   Lin->Net    = My->Net;
	   Lin->Node   = My->Node;
	   Lin->Point  = My->Point;
	   *s1 = c;
	   skipspace(s1);
	   s0 = s1;
	   skipword(s1);
/* Keep path to echoarea dupeboard */
	   if (Cfg_DupeFile == 1)
		{ int length;
		c = *s1;
		*s1 = '\0';
		Area[ar].Path = length = strlen(s0) + 1;
		while ((s0[length-1] != BACKSLASH) && (length > 0)) length--;
		if (Cfg_DupeFile) DirCheck(s0, length); else;
		strcpy((char *)(Path_Lin+Path_Sum),s0);
		Path_Sum += Area[ar].Path;
		*s1 = c;
		}
	   else;
	   while ((here_addr = cr_padr(&s1)) != HERE_EOL)
	      { 			/*    ப 	   */
	      register int i;
	      unsigned long area_off;
	      if ((here_addr == HERE_P) || (here_addr == HERE_NOADDR))
		    continue; else;
	      i = Link_Num;
	      while (cr_addr_cmp(&Link[i],Lin) == 0) i--;
#if (DEBUG == 59)
/**/	printf (" ln=%i; \"%s\" ", ln, s1);
/**/	printf ("Link[%i] = %u:%u/%u.%u@%i; ", i, Link[i].Zone, Link[i].Net, Link[i].Node, Link[i].Point, Link[i].domain);
/**/	printf ("Lin = %u:%u/%u.%u@%i\n", Lin->Zone, Lin->Net, Lin->Node, Lin->Point, Lin->domain);
#endif
	      if (i == 0) /* the same address not found */
		 {
		 Errexit(Lin_Desync,Erl_Syntax);
		 }
	      else;

	      area_off = (unsigned long)(ar) * Link_Num + i;
	      here_mask0 = 0xFF;	/* ﭨ ᮪  	   */
	      here_mask1 = 0x00;	/* ᪨   祭	   */
/* - - - - - - - -    ⥪ ⨫  - - - - - - - - - - */
	      switch (here_addr)
		{
		case HERE_P:
		  i = My_Addr_Num;	/*  ᮢ饣 	  */
		  while ((i >=0) && (cr_addr_cmp(&My[i],Lin) == 0)) i--;
		  if (i < 0)
			{
			fprintf (stderr, "\nArea: %s ",
				 (Tag_Lin + Tag_Sum - Area[ar].Tag));
			Errexit("Illegal address in -p key!", Erl_Syntax);
			}
		  else Area[ar].Org = (char)i;
		default:
		case HERE_NOADDR: continue;
/*+###045 */	case HERE_MINUSU: if (Cfg_NonSecureMinusU)
					here_mask1 = ALWO | ALRO;
				  else;
			break;
/*-###045 */
		case HERE_LINK: here_mask1 = ALIS; break;
		case HERE_PLUS: here_mask1 = ALAD; break;
		case HERE_X:	here_mask0 = ~ALWO;
				here_mask1 = ALRO; break;
		} /* switch (here_addr) */
				/* ᥭ ।  	 */
				/*  ⮢ ⠡窨   堬 */

	      AreaLink[area_off] |= here_mask1;
	      AreaLink[area_off] &= here_mask0;

	      c = *s1;
	      } /* while here_addr != HERE_EOL */
	   ar++;
	   break;

  case	HASH_Pack:

	   s0 = s1;

  case	HASH_TinySeenBys: /* switch Line[ln].Hash */
  case	HASH_ZoneGate:
  case	HASH_AddToSeen:
  case	HASH_Node:
  case	HASH_Password:
	   { register int i = 0;
	   Lin = (ADDR *)(&Link[0]);
	   Lin->Zone   = My->Zone;
	   Lin->Net    = My->Net;
	   Lin->Node   = My->Node;
	   Lin->Point  = My->Point;
	   Lin->domain = My->domain;
	   *s1 = c;
	   while ((here_addr = cr_padr(&s0)) != HERE_EOL)/*    ப */
	    {
	    i = Link_Num;
	    if (here_addr == HERE_NOADDR) continue; else;
	    /*  ᮢ饣       */
	    while (cr_addr_cmp(&Link[i],Lin) == 0) i--;
	    if (i == 0) /* the same address not found */
	       Errexit(Lin_Desync,Erl_Syntax);
	    else;

	    switch (Line[ln].Hash)
		{
		case  HASH_TinySeenBys: Link[i].Tiny	= !Link[i].Tiny; break;
		case  HASH_ZoneGate:	Link[i].Gate	= 1; break;
		case  HASH_AddToSeen:	Link[i].AddSeen = 1; break;
		case  HASH_Node:
		case  HASH_Password:
			if(!IsCfgEOL(*s1))
			     { int j, eop = 0; /*   ###039 */
			     char *s2;
			     if (Line[ln].Hash != HASH_Node)
				s2 = Link[i].PKTPassword;
#if AREAFIX_STYLE
			     else s2 = Link[i].FIXPassword;
#else
			     else s2 = NULL;
#endif
			     skipspace(s1);
			     if (s2)
			       {
			       for (j=0; j<8; j++)
				 {
				 if (IsCfgEOL(s1[j])) eop = 1; else;
				 if (eop) s2[j] = '\0';
				 else s2[j] = (char)toupper((int)s1[j]);
				 }
			       s2[8] = '\0';
			       } /* if(s2) */
			     else;
			     } /* int j, eop */
			 else;
			 break;
		case  HASH_Pack:
			     s1 = Buffer + Line[ln].offsm;
			     { int j;
			     for (j=0; j < 9; j++)
				 if (!IsCfgEOLSpace(s1[j]))
				     *(Link[i].Packer + j) = (char)toupper((int)s1[j]);
				 else { *(Link[i].Packer + j) = '\0'; break; }
			     Link[i].Packer[8] = '\0';
			     }
			 break;
		default: break;
		}
	    if ((Line[ln].Hash == HASH_Password) ||
		(Line[ln].Hash == HASH_Node) ||
		(Line[ln].Hash == HASH_Pack)) break; else;
	    } /* while here_addr != HERE_EOL */
#if (AREAFIX_STYLE & 1)
	   switch(Line[ln].Hash)
	    {
	    case HASH_Node: skipword(s1); skipspace(s1);
		if (!IsCfgEOL(*s1))
		   { /* analyse grouplist for the node */
		   Link[i].ROGroups = 0;
		   Link[i].RWGroups = 0;
		   while (IsAlpha(*s1))
		    {
		    if (*s1 > 'a')
		       Link[i].ROGroups |= ((unsigned long)1)<<(*s1 - 'a');
		    else Link[i].RWGroups |= ((unsigned long)1)<<(*s1 - 'A');
		    s1++;
		    }
		   skipspace(s1);
		   while (!IsCfgEOL(*s1))
			{ int mask;
			skipspace(s1);
			mask = (*s1++ == '+');
			if (mask || (s1[-1] == '-'))
			  switch (toupper(*s1))
				{
				case 'A': Link[i].AutoCre = mask; break;
				case 'R': Link[i].MayRescan = mask; break;
				case 'V': Link[i].SeeAll = mask; break;
				case 'I': Link[i].RuleSend = mask; break;
				case 'Y': Link[i].Notify = mask; break;
				default: break;
				}
			else;
			s1++;
			}
		   } /* if !IsEOL(*s1) in HASH_Node continuation */
	    default: break;
	    } /* switch(Line[ln].Hash) after while here_addr != HERE_EOL */
#endif /* AREAFIX_STYLE & 1 */
	   break;
	   } /* register int i block */
  default: break;
  } /* switch Line[ln].Hash */
 } /* while Next_Line Third pass */
} /* Sqw_cr3() */

/*****************************************************************************
Fills Twit tables,  Twit_Lin  line.    ⠡窨  ப ⮢.

corrects subscription tables Area??   ४ ⠡窨 ᮪  ᮮ⢥-
due  to ReadOnly/WriteOnly  options   ⢨  ﬨ ReadOnly/WriteOnly.

Fills KillDupes tables		       ⠡ KillDupes
Fills RulesMatchTag tables	       ⠡ RulesMatchTag

Fills Packer parameters of links       ࠬ Packer  .
Fills Language parameter for links     ࠬ Language  .
Fills Link LocalPaths		          .
******************************************************************************/
void Sqw_cr4()
{
int	tw = 0; 	/* 稪 ⢨ப				   */
unsigned int arnum = (unsigned int)(-1);/* ⥪騩  宮	   */
unsigned int	Link_Now = 0;	/*   ᥩ ࠡ뢠	   */
unsigned int	Area_Now = 0;	/*   ᥩ ࠡ뢠	   */

rewind (filepkt);
ln = -1;
Twit_Sum = 0;
/*************** Loop of Fourth pass ***************************************/
while ((Next_Line()) != NULL)
 {
 char	*s0, *s1, c;
 ln++; s0 = s1 = Buffer + Line[ln].offsm;
 skipword(s1);			/* s1 -   ᫥饣 ᪠	   */
 c = *s1;			/*  ᫥騩 ᨬ		   */
 *s1 = '\0';                    /*     - 㫥            */
 switch (Line[ln].Hash)
  {
  case	HASH_StartLink:
	   Lin = (ADDR *)(&Link[0]);
	   Lin->Zone   = My->Zone;
	   Lin->Net    = My->Net;
	   Lin->Node   = My->Node;
	   Lin->Point  = My->Point;
	   *s1 = c;

	   { register int i = Link_Num;
	   if (cr_padr(&s0) == HERE_NOADDR) Link_Now = 0;
	   else /*  ᮢ饣 	  */
	     {
	     while (cr_addr_cmp(&Link[i],Lin) == 0) i--;
	     if (i == 0) /* the same address not found */
	       Errexit(Lin_Desync,Erl_Syntax);
	     else;
	     Link_Now=i;
	     }
	   } /* register int i */
	   break;

  case	HASH_EndLink: Link_Now = 0; break;

  case	HASH_LocalPath:
	   if (!Link_Now)
		{
		OutLog(LEV_WARN,"LocalPath not in Link section - ignored");
		}
	   else {
		Sqw_pc(s0);
		if (DirCheck(s0, strlen(s0) - 1))
		     { AllocCpy(Link[Link_Now].localPath); }
		else OutLog2(LEV_WARN,s0, ": Can't create LocalPath - ignored");
		}
	   break;

  case	HASH_StartArea:
	   Area_Now = Find_Tag(s0, (unsigned int)(s1-s0));
	   break;

  case	HASH_EndArea: Area_Now = 0; break;

  case	HASH_Language:
	   {unsigned int i,j;
	   for (j = 0; j < 3; j++)
		if (isalnum(s0[j]))
		   {
		   Link[Link_Now].Lang[j] = s0[j];
		   if (!Link_Now)
			for (i=0;i<=Link_Num;i++)Link[i].Lang[j]=s0[j];
		   else;
		   }
		else break;
	   Link[Link_Now].Lang[3] = '\0';
	   *s1 = c;
	   }
	   break;

  case	HASH_Pack:
	   *s1 = c;
	   skipspace(s1);
	   Lin = (ADDR *)(&Link[0]);
	   Lin->Zone   = My->Zone;
	   Lin->Net    = My->Net;
	   Lin->Node   = My->Node;
	   Lin->Point  = My->Point;
	   if (cr_padr(&s1) == HERE_LINK)
		break;				/* ᫨ Pack ண ࠧ */
	   else if (Link_Now)
		   { int j;
		   s1 = Buffer + Line[ln].offsm;
		   for (j=0; j < 9; j++)
		       if ((s1[j] != '\0')
			&& (s1[j] != '\n')
			&& (s1[j] != '\r')      /* ###036 */
			&& (s1[j] != ';')
			&& (s1[j] != ' ')
			&& (s1[j] != '\t')
			  )
			  *(Link[Link_Now].Packer + j) = s1[j];
		       else { *(Link[Link_Now].Packer + j) = '\0'; break; }
		   }
		else;		/* ᫨  । StartLink,   */
	   break;		/* 祣   - DefaultPacker */

  case	HASH_NoTwitReplyTo: LASet(NotwitReply, 0); break;
  case	HASH_TwitReplyTo:   LASet(NotwitReply, 1); break;
  case	HASH_TwitUUE:	    LASet(twitUUE, atoi(s0)); break;
  case	HASH_TwitSize:	    LASet(twitSize, atoi(s0)); break;
  case	HASH_MaxOUTSize:    LASet(outSize, atoi(s0)); break;
  case	HASH_MaxMsgs:	    LASet(maxMsgs, atoi(s0)); break;
  case	HASH_MaxArchive:    LASet(arcSize, atoi(s0)); break;
  case	HASH_ForwardBad:    LASet(FwdBad, atoi(s0)); break;
  case	HASH_OriginValid:   LASet(ORValid, atoi(s0)); break;
  case	HASH_SeenByValid:   LASet(SBValid, atoi(s0)); break;
  case	HASH_RulesMatchTag: LASet(MatchTag, atoi(s0)); break;
  case	HASH_OutType:	    LASet(Outtype, atoi(s0)); break;
  case	HASH_HoldTime:	    LASet(holdTime, atoi(s0)); break;

#if ((AREAFIX_STYLE & 1) || (AREAFIX_IN_ECHOES))
  case	HASH_Alias:	    case HASH_IgnoreMsgsFrom:
#endif

  case	HASH_RulesFrom:     case HASH_RulesTo:	   case HASH_RulesSubj:

  case	HASH_TwitFrom:	    case HASH_NoTwitFrom:  case HASH_TwitSubj:
  case	HASH_NoTwitSubj:    case HASH_TwitTo:	   case HASH_NoTwitTo:
  case	HASH_TwitKludge:    case HASH_NoTwitKludge:
  case	HASH_TwitAddr:	    case HASH_NoTwitAddr:

	{ register unsigned int l; char delimiter = ' ';
	if (Twit_Num == 0) break;
	*s1=c;
#if ((AREAFIX_STYLE & 1) || (AREAFIX_IN_ECHOES))
	if ((Line[ln].Hash != HASH_Alias) &&
	    (Line[ln].Hash != HASH_IgnoreMsgsFrom))
	   {
#endif
	s1 = s0+1;
	if (isgraph(*s0)) delimiter = *s0; else;
#if ((AREAFIX_STYLE & 1) || (AREAFIX_IN_ECHOES))
	   }
	else s1 = s0;
#endif
	while ((*s1 != delimiter) && (*s1 != '\n') &&
	       (*s1 != '\r') && (*s1 != '\0')) s1++;
	*s1 = '\0';
	Twit[tw].Len = (char)(s1-s0);/*  ⢨ப */
	if (delimiter != ' ') { s0++; Twit[tw].Len--; } else;
	s1 = s0;
	for (l = 0; l < Twit[tw].Len; l++)
	    {
	    if (Twit_Lin != NULL) Twit_Lin[Twit_Sum + l] = *s0++; else s0++;
	    }
	Twit_Sum += Twit[tw].Len; /*   ⢨ ப	 */
	Twit[tw].Hash = Line[ln].Hash;
	if (rgx_here(s1) == -1)
		{
		printf (sqwish_cfg_line_n, ln);
		Errexit(Lin_RegExp,Erl_Syntax);
		}
	Twit[tw].Link = Link_Now;
	Twit[tw].Area = Area_Now;
	tw++;
	} /* l */
	break;

/*  ப   宮 */
  case	HASH_Flavor:
	Cfg_Flavor = atoi(s0); s0 = s1;

  case	HASH_ReadWrite:
  case	HASH_WriteOnly:
  case	HASH_ReadOnly:
  case	HASH_NoTwitArea:
  case	HASH_NoTwitUUE:
  case	HASH_KillDupes:

  do{	 /* ###020 */
    while ((arnum = Find_Next_Tag(s0, (unsigned int)(s1-s0))) != 0)
	{
	if (Line[ln].Hash == HASH_Flavor)
		Area[arnum].flavor = Cfg_Flavor;
	else if (Line[ln].Hash == HASH_KillDupes)
			Area[arnum].killDupes = !Area[arnum].killDupes;
	   else { unsigned int link = Link_Now;
		do { /* while link++ <= Link_Num */
		     unsigned long offf_tmp = link +
			(unsigned long)(arnum) * Link_Num;
		      switch (Line[ln].Hash)
			{
case  HASH_ReadWrite:	 AreaLink[offf_tmp] &= (~ALRO & ~ALWO); break;
case  HASH_WriteOnly:	 AreaLink[offf_tmp] &= ~ALRO;
			 AreaLink[offf_tmp] |= ALWO; break;
case  HASH_ReadOnly:	 AreaLink[offf_tmp] &= ~ALWO;
			 AreaLink[offf_tmp] |= ALRO; break;
case  HASH_NoTwitArea:AreaLink[offf_tmp] |= ALTW; break;
case  HASH_NoTwitUUE: AreaLink[offf_tmp] |= ALTU; break;
			} /* switch Line[ln].Hash */
		   if (Link_Now) break; else;
		   }
		while (++link <= Link_Num);
		} /* else HASH_KillDupes */
	} /* while (arnum = Find_Next_Tag()) */

/*  祪 ॠ   ப KillDupes */
    if ((!arnum) && (Line[ln].Hash == HASH_KillDupes) && (s1 == s0))
	    do Area[arnum].killDupes = !Area[arnum].killDupes;
	    while (++arnum < Area_Num);
    else;
    *s1 = c; s0 = s1;
/*+###020 */
    skipspace (s0); s1 = s0;
    skipword (s1); c = *s1; *s1 = '\0';
    }
  while (s0 != s1);	/*    ⠣  ப */
/*-###020 */
  break;
  default: break;
  } /* switch Line[ln].Hash */
 } /* while Next_Line Fourth pass */

/* Sets ALUP and ALDN bits from ALRO, ALWO, ALIS bits - - - - - - - - - - - */
{ char tabAL[8] = { 0, (ALUP | ALDN), 0, ALUP, 0, ALDN, ALUP, ALUP};
unsigned long area_off = AREA1ST * Link_Num;
while (++area_off < ((unsigned long)Area_Num * (Link_Num + 1)))
	AreaLink[area_off] |= tabAL[7 & AreaLink[area_off]];
} /* char tabAL[] */
} /* Sqw_cr4() */
