/* sqw-msg.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Generating messages subroutines.
 * Assume fileout to be opened.
 *
 * Assume link is in our Link[] ta-
 * ble if link is non-zero, and  is
 * kept in Link[0] if  non-zero. It
 * simpilies logic of these functi-
 * ons.
 *
 */

#include "./sqw-inc.h"

/*
 * Generates and write header and
 * technical kludjes.
 *
 */

void msg_netmail_begin(
unsigned int link,		/* link number in table. Addres To: of msg. */
unsigned int arorig,		/* My address number in table. AddrFrom:    */
char *from,			/* From field				    */
char *to,			/* To field				    */
char *subj			/* Subj field				    */
)
{

mh.PakdMessage = 2;
mh.AttributeWord = 0;

mh.destNode = Link[link].Node;
mh.destNet  = Link[link].Net;

mh.origNode = My[arorig].Node;
mh.origNet  = My[arorig].Net;

mhdatime(&mh);

fwrite(&mh, sizeof(mh),1,fileout);		/* Header written */
fputs (to, fileout); fputc('\0', fileout);
fputs (from, fileout); fputc('\0', fileout);
fputs (subj, fileout); fputc('\0', fileout);

if (Link[link].Zone != My[arorig].Zone)
   fprintf (fileout,  Format_INTL,
    Link[link].Zone, Link[link].Net, Link[link].Node,
    My[arorig].Zone, My[arorig].Net, My[arorig].Node);
else;

if (My[arorig].Point) fprintf(fileout, Format_FMPT, My[arorig].Point);
else;

if (Link[link].Point) fprintf(fileout, Format_TOPT, Link[link].Point);
else;

fprintf(fileout, Format_MSGID,
	My[arorig].Zone, My[arorig].Net, My[arorig].Node,(unsigned long)ttt);

} /* msg_netmail_begin() */

/*
 * Finishes  message  with  writing
 * buffer, tearline and  last  zero
 * byte to fileout. Checks error of
 * writing. If success - returns 1.
 * If error detected - returns 0.
 *
 */


int msg_netmail_end(char *buffer, char *progress)
{
fprintf(fileout, Format_rsr, buffer);		/* text itself (invalidated) */
fprintf(fileout, sVersion, rTear,		/* tearline */
	SQW_VERTYPE, SQW_VERSION, SQW_SUBVERS, your_compiler);
fputc('\r', fileout);                           /* End of message            */
fputc('\0', fileout);                           /* Last zero byte of message */
if (ferror(fileout))
	{
	OutLog2(LEV_LOOSE,progress, Write_Error);
	return 0;
	}
else	return 1;
} /* msg_netmail_end() */
