/* sqw-type.h * Content-Type: TEXT/PLAIN; charset=cp866
 *
 ********************* types definition ***********************************/
/* byte, word, dword defined in sqw-os.h */

/* ====================================================================== */
typedef struct	{		/* Config line info structure             */
unsigned short int	Hash;	/* Keyword hash result			  */
unsigned short int	offsm;	/* Offset to line continuation		  */
	} LINE;			/******************************************/

typedef struct	{
unsigned short int	Zone;	/*  				  */
unsigned char		*name,	/*    ப 		  */
			*dir;	/*  ४ਨ ⡠㭤      */
	} DOMAIN;
typedef struct	{		/********* 8    ****************/
unsigned short int		/*					  */
		Zone,		/*					  */
		Net,		/*					  */
		Node,		/*					  */
		Point,		/*					  */
		domain;		/*    ⠡窥 	  */
	} ADDR;			/******************************************/
typedef struct	{		/******************************************/
unsigned short int		/*					  */
		Zone,		/*					  */
		Net,		/*					  */
		Node,		/*					  */
		Point,		/*					  */
		domain,		/*					  */
		twitUUE,	/* minimum twit UUE size in lines         */
		twitSize,	/* maximum sending message size in KBytes */
		outSize,	/* maximum out packet size for this link  */
		arcSize,	/* maximum archive size for this link     */
		maxMsgs,	/* maximum number of msgs in out packet   */
		holdTime;	/* maximum number of days to keep arcmail */
unsigned char   PKTPassword[9];	/* Packets' password for this link	  */
#if AREAFIX_STYLE
unsigned char   FIXPassword[9];	/* AREAFIX's password for this link	  */
#endif
unsigned char   Packer[9];	/* Packer line from 'Pack' keyword        */
unsigned char	Lang[4];	/* Language 3 chars description		  */
unsigned char  *localPath;	/* LocalPath for moving packets		  */
unsigned long	OutAdd;		/* Prognosis size of arcmail created now. */
unsigned long	OutMin,		/* start/end hex numbername .out packets  */
		OutMax;		/* to be packed in arcmail for this link  */
unsigned char	OutExt[3];	/* Extention of this acrmail		  */
unsigned int	NotwitReply: 1;	/*  ⢨⮢ ᠣ Reply ⮣ */
unsigned int	Tiny	 : 1;	/* TinySEENBYs				  */
unsigned int	Gate	 : 1;	/* FTN Gating To/From this link		  */
unsigned int	AddSeen  : 1;	/* Global AddSeen this address to SEEN-BYs*/
unsigned int	FwdBad   : 1;	/* Forward .OPS .OSC .OBD .OBT packets?   */
unsigned int	ORValid  : 2;	/* Check Origin validate?                 */
unsigned int	SBValid  : 1;	/* Check SEEN-BY validate?                */
unsigned int	Subscr	 : 1;	/* ਧ 祭  SEEN-BY ᫥ .*/
unsigned int	MatchTag : 1;	/* Match Tag in From/Subj when rules extr */
unsigned int	Outtype  : 1;	/* Type of generated packet for this link */
unsigned int	Update : 1;	/* Needed reply about update impossible	  */
#if AREAFIX_STYLE
unsigned int	RuleSend : 1;	/* Send rules of new subscribed areas     */
unsigned int	MayCreate : 1;	/* Allowed %CREATE requests  to this link */
unsigned int	MayDestroy : 1;	/* Allowed %DESTROY requests to this link */
unsigned int	MayRescan : 1;	/* Allowed %RESCAN requests for this link */
unsigned int	AutoCre : 1;	/* Allowed autocreate areas from link     */
unsigned int	SeeAll : 1;	/* Every group is seen to link		  */
unsigned int	Notify : 1;	/* DisAllow notify requests		  */
unsigned long	RWGroups;	/* Bit mask of groups allowed for link    */
unsigned long	ROGroups;	/* Bit mask of groups R/O  for this link  */
#endif
	} LINK;			/******************************************/
typedef struct	{		/* Echoarea structure                     */
unsigned char	Tag,		/* Length of echotag in Tag_Lin		  */
		Org;		/* What my address is in PATH/SEEN-BY?	-p*/
unsigned short int Path;	/* Length of path in Path_Lin             */
unsigned       int
		killDupes : 1,	/* Kill dupes for this echoarea?	  */
		flavor    : 4,	/* Flavor for echoarea                    */
		MatchTag  : 1,	/* Match Tag in From/Subj when rules extr */

				/* This parameters are not needed for Area*/
		twitUUE : 1,	/* But they are setted by LASet for simp- */
		twitSize : 1,	/* lification of it's checks...		  */
		outSize : 1,
		maxMsgs : 1,
		arcSize : 1,
		holdTime : 1,
		NotwitReply: 1,
		ORValid  : 1,	/* Check Origin validate?                 */
		SBValid  : 1,
		FwdBad   : 1,
		Outtype  : 1;
#if AREAFIX_STYLE
unsigned int	RuleSend : 1;	/* Send rules of new subscribed areas     */
unsigned int	MayRescan : 1;	/* Allowed %RESCAN requests for this area */
unsigned int	Group : 5;	/* Group number                           */
unsigned int	GroupRO : 1;	/* Group read-only flag			  */
unsigned int	Seen : 1;	/* Allowed to be seen for links           */
unsigned int	Update : 1;	/* Needed update EchoArea line		  */
#endif
unsigned char	Lang[3];	/* Language 3 chars description		  */
	} AREA;			/******************************************/
typedef struct	{		/* NewEchoarea structure                  */
unsigned char	*Line;		/* Echotag 				  */
unsigned short	Link;		/* Link number for autocreate		  */
void	 huge	*Next;		/* Pointer to the next structure	  */
	} NEW;			/******************************************/
typedef struct	{		/* Message info structure                 */
unsigned short int	Area;	/* Area number in table			  */
unsigned short int	Link;	/* Link number in table - whose .PKT?     */
unsigned short int	Reply;	/* Our Point number in REPLY kludge       */
unsigned char		PKT;	/* PKT number in table			  */
unsigned long	Offset;		/* Offset in PKT file			  */
unsigned long	OffTear;	/* Offset in PKT file	tearline	  */
unsigned long	OffOrig;	/* Offset in PKT file	origin		  */
unsigned long	OffSeen;	/* Offset in PKT file	seen-by		  */
unsigned long	OffPath;	/* Offset in PKT file	path		  */
unsigned long	Length;		/* Full Length of message		  */
unsigned long	offAddr;	/* Offset to addresse in Origin		  */
unsigned long	DupeID;		/* Dupe ID information			  */
unsigned long	SplitID;	/* Split ID information			  */
unsigned char	lenAddr;	/* Length of addresse in Origin		  */
unsigned char	WhatBad;	/* WhatBad in bad message?		  */
unsigned short int UUElines;	/* Number of UUE-like lines in message	  */
unsigned short int rule: 1;	/* Is this message - rules of echoarea?   */
unsigned short int AFIX: 1;	/* Is this message - correct to AREAFIX?  */
unsigned short int LTo: 6;	/* Length of To field			  */
unsigned short int LFrom: 6;	/* Length of From field			  */
unsigned short int LSubj: 7;	/* Length of Subj field			  */
unsigned short int INTL: 1;	/* Correct INTL kludge exists in message  */
unsigned short int MSGID: 1;	/* Correct FTN-addressed MSGID kludge     */
unsigned short int DOMAIN: 1;	/* Correct DOMAIN kludge exists in message*/

unsigned char dMy;		/* Number of our own address (default 0)  */
unsigned short int
    oZone, oNet, oNode, oPoint,	/* Netmail originating address		  */
    dZone,dNet,dNode,dPoint;	/* Netmail destination address		  */

	} MSG;			/******************************************/
typedef struct	{		/* TwitItem structure                     */
unsigned char	Len;		/* Length of twitline in Twit_Lin	  */
unsigned short int Link;	/* Link number for twitline		  */
unsigned short int Area;	/* Area number for twitline		  */
unsigned short int Hash;	/* Hash of config word used for this item */
	} TWIT;			/******************************************/
