/* sqwarc.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * (C) 1998 Sergej Qkowlew     2:5020/122@fidonet		 ࣥ 
 *
 *				 V01.03
 *
 * ================================   =========================================
 * Tool for  packing oubound  files   ணࠬ 㯠  室 બ  
 * with using rules in	squish-like   ਬ ࠢ  ᪢订	䠩 
 * file compress.cfg.		      ᠭﬨ 娢஢ - compress.cfg.
 *
 * Version 01.03+: ================   =========================================
 *
 * First parameter begins with '@':    ࠬ ᪠ 稭  '@':
 *
 * @+sqwash.bat - paranoic	      ᯮ塞 䠩    PATH
 * @-sqwash.bat - not paranoic	      ᯮ塞 䠩   PATH
 *
 * File sqwash.bat is analysed seq-    sqwash.bat ⠥ ᫥⥫쭮,
 * uentially, each line  is interp-     ப   -
 * reted as command line of  sqwarc    ப sqwarc   ,  
 * in elder versions  (but  without    ࠭祭  	 -
 * limitation to MaxCommandLength!)   , ஥ ⠪ 蠫  !
 *
 * Optional parameters:               ⥫ ࠬ:
 *
 * second and third  params - names   ன  ⨩ ࠬ -  䠩
 * of file  s  (lines that were not   s (ப, ᯮ  뫮 ⫮-
 * executed by reason of .bsy flags    - 䫠 )  e (ᯮ-
 * existing) and file e (lines were    ⫮  -  訡  -
 * not executed to some other error    㯠/६饭 䠩.
 * during packing/moving process).
 *
 * If fourth parameter exists  - it   ᫨   ப    
 * is compress.cfg pathfilename.      ࠬ -     compress.cfg.
 *
 * TOSSING_LOG = 1:
 * If fifth  parameter	exists - it   ᫨   -      
 * is log pathfilename	(stdout  is     ( ᮮ饭   stdout).
 * used as default).
 *
 * Version 01.02 is small corrected    01.02 ᫥ ⪮४஢ 
 * to diminish memory  held  before   㬥襭 ࠧ ⮩   ।
 * calling archiver. No logfile  in   ᪮ 娢.   ᨨ   -
 * DOS version possible. :-(	        뢮  -䠩. ;-(
 *
 * Version 01.00+:
 *
 * If zero-length  arcmail detected   ᫨  ଠ쭮 બ -
 * instead of normal file - program     - ணࠬ  "६-
 * 'increments' file  extention  to   " ७ 䠩,     
 * find non-existant. If all possi-   ᢮. ᫨   ७
 * ble extentions are busy  -  take    䠩 -  ᫥ -
 * last found;	if arcmail is trun-   ; ᫨ બ  ⨬ ७ -
 * cated - delete it.		       -  .
 *
 * Now we read .DLO file  to  check     ஢塞  稥  뫪  
 * existance of reference  to  arc-   બ  䠩 .DLO,  塞 뫪
 * mail, and reference is added on-   ⮫쪮 ᫨  ⢨⥫쭮  室-
 * ly if really needed. 	      .
 * ================================   ========================================
 * Replaces DOS batch file >>>> sqwarc.bat <<<<<<<    䠩,
 * with more effective logic,  more       ४	 ࠡ,
 * correct work  when TruncSent op-   ᮡ  樨 TruncSent.   ⠢-
 * tion is set. But less Conventio-    ᪠ 娢ࠬ   -
 * nal	memory left for running ar-        (  㠫쭮
 * chivers under DOS (actual for HA    HA  RAR'a, ਬ).
 * and RAR, for example).
 *
 * Checks/Creates .bsy flags.	      ஢/ᮧ ४⭮ .bsy 䫠.
 *
 * For existant arcmails checks ar-    㦥 騥 બ  뢠
 * chiver's type and  run  archiver   娢஬    ᮮ⢥⢨  ᮤন
 * according to it's real type, not   બ,    㪠  ⮬  -
 * by described by argv[5].	       ᪠.
 *
 * Errorlevels (global):              ૥:
 *  0 - success summary process	      ᯥ譮 襭 㬬୮ .
 * 10 - not enough memory to work.     墠⨫   ࠡ.
 * 11 - compress.cfg not found/wrong.     compress.cfg
 * 12 - sqwash.bat not found/wrong.       sqwash.bat
 * 13 - execvp error (impossible?).   訡 ᯮ execvp.
 *
 * Bink-Style Only		      쪮 -⠩ .
 *
 * Distribution:		      ᮡ ࠭:
 * Source code under GNU license.      室 ⥪,  ࠬ GNU.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include <fcntl.h>


#include "./sqw-os.h"   /* OS-aware definitions */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define MAXARGS 20	/* ᨬ쭮 ⢮ 㬥⮢ args[]	    */
#define MAXARGH 7	/* ᨬ쭮 ⢮ 㬥⮢ argh[]	    */
#define ARCMAX 40	/* ᨬ쭮 㥬 ᫮ 娢஢	    */
#define MAXLINE 4096	/* ᨬ쭠  ப ⠥  䠩	    */
#define LENEXT 3	/*  ७ 䠩 (᫥ ᫥ 窨)   */
#define TOSSING_LOG 1	/* ᫨ 0 -  UNIX ⮫쪮 syslog. DOS - stdout    */
/* =========== ⨯   㭪権 =========================== */
void	Read_Compress_Cfg(void);
int	From_Compress_Cfg(void);
int	System(void);
void	Write_Line_Back(int, char **, char *);
void	Write_Line_Dlo(void);
int	Move(char *, char *);
void	Remove_arc(int, char **);
void	strcpy2(char *, char *, char, char *);
/* ============ 饭  訡    =========================== */
char	*sqwarc;			/* name of running programm	    */

static char
	IO_Error[] = "File not found or I/O Error: ",
	Cant_move[] = "Can't move file ",
	to[] = " to ",
	Cant_append[] = "Can't append line ",
	empty[] = "";

#if (defined(UNIX))

#include <sys/types.h>
#include <sys/wait.h>

static char Format_ssss[] = "%s%s%s%s";
#define OutLog4(A,B,C,D) syslog(LOG_INFO,Format_ssss,A,B,C,D)

#else /* UNIX */

#include <process.h>

#if TOSSING_LOG

static char *tossing_log = NULL;
static FILE *filelog = NULL;
#define openlog(A,B,C)	if (tossing_log) filelog = fopen(tossing_log,at); else
#define closelog() if (filelog) fclose(filelog); else

/* =========== 뢮    ப  ᡮ   ப =========== */
void OutLog4(char *s1, char *s2, char *s3, char *s4)
{
if (filelog == NULL) filelog = stdout; else;
fputs(sqwarc, filelog);
fputs(": ",filelog);
fputs(s1,filelog);
fputs(s2,filelog);
fputs(s3,filelog);
fputs(s4,filelog);
fputc('\n', filelog);
} /* OutLog4() */

#else /* TOSSING_LOG */

#define openlog(A,B,C)

void OutLog4(char *s1, char *s2, char *s3, char *s4)
{
fputs(sqwarc, stdout);
fputs(": ",stdout);
fputs(s1,stdout);
fputs(s2,stdout);
fputs(s3,stdout);
puts(s4);
} /* OutLog4() */
#define closelog()

#endif /* else TOSSING_LOG */
#endif /* else UNIX */

#include "./sqw-bsy.c"  /* .bsy files creation and deleting subroutines */

static char Begin_Extract[] = YOUR_OS;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
static	int	LowerCase = 1;
static	int	paranoia = 0;		/* if 1 - not search exec in PATH   */
static	char *dlo[] = {".DLO", ".dlo"}; /* Extention for .?LO files         */
static	char *out[] = {".OUT", ".out"}; /* Extention for .OUT files         */
static	char *pkt[] = {".PKT", ".pkt"}; /* Extention for .PKT files         */
static	char *Ss[]  = {"S", "s"};       /* s. filename                      */
static	char *Ee[]  = {"E", "e"};       /* e. filename                      */
static	char *Aa[]  = {"A", "a"};       /* to increment last char of ext    */
static	char *Zz[]  = {"Z", "z"};       /* to increment last char of ext    */

static	char	pathname_dlo[MAXPATH+1];
static	char	pathname_out[MAXPATH+1];
static	char	pathname_pkt[MAXPATH+1];
char	*pathname_arc;			/* arcmail path+name+ext	    */
char	*arctype = "ZIP";               /* Default packer if no %5 param    */

static char	*compress_cfg = "compress.cfg",         /*  䨣      */
		rb[] = "rb", at[] = "at", rt[]="rt";    /* ਡ fopen   */
static char const tabspace[] = " \t";                   /*  strtok       */
static char	before_path;		/* # or ^ in .dlo file		    */
static struct stat f;			/*   㭪樨 stat	    */
static FILE *filein;			/* ਯ  fopen/...	    */
/*
static char Buffer[MAXLINE+2];
*/
static char	*argh[MAXARGH];	 	/* ஠஢ ப  .bat */
static char	*args[MAXARGS]; 	/*   spawnvp/execvp	     */

static		int  arcmail_not_here;	/* 稥 બ argv[3]	    */

/* ============ 뢠 ॢ ப    ================== */
void ClearEOL(char *s0)
{while (*s0) if ((*s0 == '\r') || (*s0 == '\n')) *s0 = '\0'; else s0++;}
/* ============ ઠ  ப   c  ᨬ  ======= */
void	strcpy2(char *s0, char *s1, char c, char *s2)
{
while (*s1) *s0++ = *s1++;
if (c) *s0++ = c; else;
while (*s2) *s0++ = *s2++;
*s0++ = '\0';
} /* void strcpy2(char *s0, char *s1, char *s2) */

/* ============================================================================
 * Invoke system command and return   맢 ⥬      
 * with errorlevel to be analysed.    祭  襭  .
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
int	System()
{
int k = 0, Summary = 0;

/* ------ Check summary length and path lengths in args -------------------- *
 * And do NOT tell me about 'no li-    ⮫쪮       ⢨
 * mits' in your OS!                  ࠭祭  襩 !
 * ------------------------------------------------------------------------- */
for (k = 0; k < MAXARGS; k++)
    {
    Summary += strlen(args[k]);
    if (args[k])
      {
      if(strlen(args[k]) > MAXPATH)
	{ OutLog4("Too long path ", args[k], empty, empty);
	return 255;
	}
      else;
      if (Summary > MAXCMDLEN)
	{ OutLog4("Too command line built for archiver running",
		empty, empty,empty);
	return 255;
	}
      else;
      } /* if (args[k]) */
    else break;
    } /* for k < MAXARGS */

#if DEBUG
/**/while(args[k]) printf(" %s", args[k++]); puts(empty);
/**/fputs("System(); Press Enter to continue sqwarc executing>", stderr); getchar();
#endif

#ifdef UNIX
if(fork()) { wait(&k); k = WEXITSTATUS(k); }
else	{
	if (paranoia) execv(args[0], args);
	else execvp(args[0], args);
	exit(13);
	}
#else /* UNIX */
if (paranoia)	k = spawnv(P_WAIT, args[0], args);
else		k = spawnvp(P_WAIT, args[0], args);
#endif /* else UNIX */
return k;
}

/* ============================================================================
 * Appends line of argv[]  to  file   뢠 ப   㬥⮢	argv  
 * named "s" or "e"  for later use,   䠩, 㥬 "e"  "s"   ⫮-
 * if packing can not  be completed     ⮬ ᯮ짮, ᫨ 㯠-
 * for some reason (.bsy flag  cau-         襭.  .bsy  䫠
 * ses file "s", packing errors - e   -  䠩 s, 訡 -  䠩 e.
 * ------------------------------------------------------------------------- */
void	Write_Line_Back(int argc, char **argv, char *s)
{
register int i;
FILE *filebat = fopen (s,at);

if (filebat == NULL) OutLog4(Cant_append, to, s, empty);
else
    {
    for (i = 0; i < argc; i++)
	{
	fputs(argv[i], filebat);
	fputc(' ',filebat);
	}
   fputc ('\n',filebat);
   fclose (filebat);
   }
} /* Write_Line_Back */

/* ========================================================================= *
 * Reads .dlo file if exist. If  it   ⠥ 䠩  .dlo, ᫨    .
 * contains reference to our arcma-   ᫨     뫪  બ -  
 * il - returns. If do	not contain   祣  .  ᫨ 뫪  - 
 * reference - append line to it.      ᮮ⢥   .dlo
 * ------------------------------------------------------------------------ */
void	Write_Line_Dlo()
{
int reference = 1;
unsigned	char tmp[MAXLINE+1];	/* ஬筠 ப 	    */
FILE *filebat;

filebat = fopen(pathname_dlo,rt);
if (filebat)
   {
   while(fgets(tmp,MAXLINE,filebat) && reference)
#if (defined(__TURBOC__))
	if (!strnicmp(tmp + 1, pathname_arc, strlen(pathname_arc)))
#else
	if (!strncmp(tmp + 1, pathname_arc, strlen(pathname_arc)))
#endif
		reference = 0;

	else;
   fclose(filebat);
   if (!reference) return; else;
   }
else;
/* V01.00- */
filebat = fopen(pathname_dlo,at);
if (filebat)
	{
	fputc(before_path,filebat);
	fputs(pathname_arc,filebat);
	fputc('\n',filebat);
	fclose(filebat);
	}
else	OutLog4(Cant_append, pathname_arc, to, pathname_dlo);
} /* Write_Line_Dlo */

/* ------------------------------------------------------------------------ *
 * Deletes arcmail.		      ࠥ 䠩 બ.
 * ------------------------------------------------------------------------ */
void Remove_arc (int argc, char *argv[])
{
if (remove(argv[3]))		/*   	     */
   {				/* 㤠筠 ⪠  */
   Write_Line_Back (argc, argv, Ee[LowerCase]);
   bsy_remove();
   exit(1);
   }
else;
} /* void Remove_arc */

/* ============================================================================
 * Returns 0 if success
 * Or result of System or unlink.
 * ------------------------------------------------------------------------- */

int Move (char *otkuda, char *kuda)
{

#ifdef UNIX

link(otkuda, kuda);
switch(errno)
	{
	case 0:
		if (unlink(otkuda)) return 1; else return 0;
	case EXDEV:    case EPERM:    case EMLINK:
/*
 * If link is impossible  for  some   ᫨  ᤥ  link    
 * reasons  -  shell command  mv is   稭 - 뢠  襫 mv.
 * invoked.
 */
		args[0] = "mv";
		args[1] = otkuda,
		args[2] = kuda;
		args[3] = NULL;
		return (System());
	default:
		return 1;
	} /* switch errno */

#else	/*   ᮬ 襢 ࠧ  move */
		args[0] = "move";
		args[1] = "/Y";
		args[2] = otkuda,
		args[3] = kuda;
		args[4] = NULL;
		return (System());
#endif
} /* int Move() */

static unsigned int  Num_Arcs;		/* ᪮쪮 稫 娢஢   */
static		long Offset[ARCMAX];	/* 饭  Ident		    */
static unsigned long Length[ARCMAX];	/*  ᫥⥫쭮 ⮢  */
static unsigned char *Ident[ARCMAX];	/*  ᫥⥫쭮 ⮢   */
static unsigned char *Add[ARCMAX];	/* ப  ᪠ 娢    */
static unsigned char *Name[ARCMAX];	/*  娢 (Pack)    */
static int  ArcNow = -1;		/*  娢 ப ᪠  */

/* ============================================================================
 * Reads compress.cfg and fills ta-   ⠥ compress.cfg,  ⠡窨.
 * bles.
 * ------------------------------------------------------------------------- */
void Read_Compress_Cfg()
{
unsigned char tmp[MAXLINE+2];	/* ஬筠 ப 	    */
int i,j;
char *s0,*s1;

if ((filein = fopen(compress_cfg,rt)) == NULL) exit(1);else;
/* ======================= Compress.cfg analysing ======================== */
i = 0;					/*  ⥪饣 娢	   */
j = 0;					/*   	   */
while (fgets(tmp,MAXLINE,filein))	/* ⠥ । ப 䨣 */
	{
	ClearEOL(tmp);
	s0 = strtok(tmp, tabspace);
	if (!stricmp(s0, "Archiver"))   /* 砫 娢 */
		{
		j = 1;
		Length[i] = 0;		/* ਧ  ।     */
		Offset[i] = 0;
		s0 = strtok(NULL, " \t;\r\n");
		Name[i] = malloc(strlen(s0));
		if (!Name[i]) exit(1);
		else strcpy(Name[i], s0);
		continue;
		} /* "Archiver" */
	else;
	if (j && !stricmp(s0, "End"))
		{				/* 砭 娢      */
		j = 0;
		if ((i == ArcNow) && (Length[i] == 0)) ArcNow = -1; else;
		i++;
		if (i >= ARCMAX) exit(1); else;
		continue;
		} /* "End" */
	else;
	if (j)	{
		if (!stricmp(s0, Begin_Extract))	/* ᮮ⢥   */
		   s1 = strtok(NULL, tabspace); 	/*  ப ய */
		else s1 = s0;
		if (!stricmp(s1, "Add"))                /* ப add        */
		   {
		   s0 = s1 + strlen(s1) + 1;		/* s0 -  砫   */
		   if ((Add[i] = malloc (strlen(s0) + 9
			+ MAXPATH + MAXPATH)) == NULL) exit(1);
		   else;
		   strcpy(Add[i],s0);
		   continue;
		   } /* if "Add" */
		else;
		if (!stricmp(s0, "Ident"))
		   {
/* ᬥ饭 */	   if ((s0 = strtok(NULL, ",")) == NULL) continue; else;
		   Offset[i] = atol(s0);
/* 蠡 */	   if ((s1 = strtok(NULL, tabspace)) == NULL) continue; else;
		   Length[i] = strlen(s1) / 2;
		   if ((s0 = malloc(Length[i] + 2)) == NULL) exit(1); else;
		   Ident[i] = s0;
/* 㥬 蠡 */	for (j = 0; j < (int)(Length[i]); j++)
			{
			*s1 = (char)toupper((int)(*s1));
/*   */	*s0 = (char)((*s1 <= '9')?(*s1 - '0')
					    :((int)(*s1) - 'A' + 10));
			*s0 <<= 4;
			s1++;
			*s1 = (char)toupper((int)(*s1));
/*   */	*s0 += ((*s1 <= '9')?(*s1 - '0')
					   :(*s1 - 'A' + 10));
			s1++;
			s0++;
			} /* for j < Length[i] */
		   j = 1;
		   continue;
		   } /* if "Ident" */
		else;
		} /* if j */
	else;
	} /* while(fgets) */
if (i == 0)
	{
	fputs("No archivers defined in ", stdout);
	puts(compress_cfg);
	exit(1);
	}
else Num_Arcs = i;
fclose(filein);
} /* Read_Compress_Cfg */

/* =====================  娢  ⭮ બ? ======== */
int From_Compress_Cfg()
{
int matched, i,k;
char *s0;
static unsigned char tmp[MAXLINE+2];	/* 			    */

/* =============================== Is here arcmail? ======================== */
stat(pathname_arc,&f);
if (f.st_size) filein = fopen(pathname_arc,rb); else filein = NULL;
/* =============================== Reading arcmail ========================= */
matched = 0;
for (i = Num_Arcs - 1; i >= 0; i--)	/* 横 ॡ 娢஢ */
					/*   બ      */
	{
	if (Length[i] == 0) continue; else; /*  ।  */
/* ᫨ બ  -  ࠢ  ப arctype */
	if (arcmail_not_here || (filein == NULL))
	   if (!stricmp(Name[i], arctype)) break; /* ᮢ - 室 */
	   else continue;		/*  ᮢ - த ᪠ */
	else;
/* ᫨  બ - 饬 ᨣ  䠩 */
	if (Offset[i] < 0)		/*     */
	   fseek(filein,Offset[i],SEEK_END);
	else				/*   砫 䠩 */
	   fseek(filein,Offset[i],SEEK_SET);
	k = fread((void *)tmp,1,(size_t)Length[i],filein);
	if (k != (int)(Length[i]))
		{			/* ᫨ ⠫    */
		continue;		/* ஡ 㣮 .   */
		}
	else;
	matched = 1;
	for (k = 0; k < (int)(Length[i]); k++)	/* 横 ࠢ ᫥- */
						/* ⥫쭮⥩  Ident  䠩*/
	    if (tmp[k] != *(Ident[i] + k))
		{
		matched = 0;		/*  ᮢ		     */
		break;
		}
	    else;

	if (matched) break; else;	/* ᮢ		     */
	} /* for i = Num_Arcs; i-- */
if (filein) fclose(filein); else;		/*  બ	    */
if (i < 0) return 0; else;			/*  稫 娢   */

strcpy(tmp,Add[i]);				/* ஢   tmp*/
args[0] = strtok(tmp,tabspace);
i = 0;
while((args[++i] = strtok(NULL, tabspace)) != NULL)
	{
	s0 = args[i];
	if (*s0 == '%')
	   {
	   s0++;
	   if (*s0 == 'a') args[i] = pathname_arc; /* %a  */
	   else
	      if (*s0 == 'f')           /* %f  argv[1].pkt */
		 args[i] = pathname_pkt;
	      else;
	   } /* if *s0 == '%' */
	else;
	} /* while ((args[++i] = strtok) != NULL) */
/*   args 㦭    */
#if DEBUG
/**/puts("\nargs:"); for (k = 0; k <= i; k++) printf("%s ", args[k]);
/**/fputs("End of From_Compress_Cfg. Press Enter to continue>", stderr); getchar();
#endif
return 1;
} /* From_Compress_Cfg() */


/* ====================  ப  ᮡ⢥ ࠡ ================= */
void Line_Analysis(int argc, char **argv)
{
char *lastchar, *s0;
int k;

#if DEBUG
/**/puts(""); for (k = 0; k < argc; k++) printf("%s ", argv[k]); puts("");
#endif
pathname_arc = argv[3]; lastchar = pathname_arc + strlen(pathname_arc) - 1;
before_path = *argv[4];
LowerCase = 0;
if (before_path == 'd') {LowerCase = 1; before_path = '#';} else;
if (before_path == 'g') {LowerCase = 1; before_path = '^';} else;

if (argc != 5) arctype = argv[5]; else;

/* ------------------ Move file to LocalPath ------------------------------ */
if ((argc == 6) && (!stricmp(argv[5], "LOC")))
    {
    strcpy2(pathname_out, argv[1],'.',argv[3]);
    (Move(pathname_out, argv[2]));
    return;
    } /* if LOC */
else;

/* ------------------ Check - what .o?? file exists here? ----------------- */
strcpy2(pathname_out,argv[1],'\0', out[LowerCase]);
if (stat(pathname_out,&f))
   {
   s0 = argv[3] + strlen(argv[3]) - LENEXT - 1;/* s0 - 㪠뢠 ७ */
						/* 室 䠩	     */
   strcpy2(pathname_out, argv[1], '\0', s0);
   if (stat(pathname_out,&f))
	{
	OutLog4(pathname_out, " - Not found file to be sent",empty,empty);
	Write_Line_Back (argc, argv, Ee[LowerCase]);
	return;
	}
   else {	/*  뫠 䠩,    .out -     */
	arctype = NULL;
	} /* else stat("name.ops,...") */
   } /* if stat("name.out") */
else;

strcpy2(pathname_dlo, argv[2], '\0', dlo[LowerCase]);
strcpy2(pathname_pkt, argv[1], '\0', pkt[LowerCase]);

if ((before_path != '#') && (before_path != '^')) return; else;

if (bsy_create(argv[2], ".bsy") == -1)/*    */
    Write_Line_Back (argc, argv, Ss[LowerCase]);
else{
    if (arctype)
	{				/*  ᮧ ᢮    */
/* V01.00+ (Was trivial removing zero-length arcmail) */
	do {
	   arcmail_not_here = stat(pathname_arc,&f);
	   if (!(arcmail_not_here)) /*  બ */
	      if (f.st_size == 0L)			/*  㫥  */
		{
		if ((before_path == '#') &&     /* ᫨  ᥪ */
		    ((*lastchar) < *(Zz[LowerCase])))/*    	*/
		    if ((*lastchar) == '9')
			 *lastchar = *Aa[LowerCase];
		    else (*lastchar)++;
		else {				/*    */
		     Remove_arc(argc, argv);
		     arcmail_not_here = 1;
		     }
		} /* if (f.st_size == 0L) */
	      else break;			/* 㫥 બ */
	   else break;				/*  બ */
	   }
	while (!arcmail_not_here);
/* V01.00- */
	if ((!From_Compress_Cfg()) ||	/* ᫨   娢  */
	    (rename (pathname_out, pathname_pkt))) /*  २*/
		{
		Write_Line_Back (argc, argv, Ee[LowerCase]);
		bsy_remove();
		return;
		}
	else;
/* ᫨  -   args 㦥    spawnvp/execvp */
	k = System();
#if DEBUG
/**/	printf ("\nReturned code %i\n", k);
/**/	printf ("Press any key to continue>"); getchar();
#endif
	if (k == 0)			/* ᯥ譠 㯠 PKT  બ  */
		{
		Write_Line_Dlo();
		remove(pathname_pkt);
		}
	else	{
		rename(pathname_pkt,pathname_out);
		OutLog4("Error packing ", pathname_pkt, to, pathname_arc);
		Write_Line_Back (argc, argv, Ss[LowerCase]);
		}
	} /* if arctype */
    else{
	if ((k = Move(pathname_out, argv[3])) == 0)
	   Write_Line_Dlo();
	else {
	     OutLog4(Cant_move,pathname_out, to, argv[3]);
	     Write_Line_Back (argc, argv, Ee[LowerCase]);
	     }
	} /* else arctype */
    bsy_remove();
    }/* else bsy_create */
return;
} /* Line_Analysis() */

/* ===========  ணࠬ ========================================= */
void main (int argc, char **argv)
{
#if (defined(__TURBOC__))
short int dummy;	/* 窠 ⨢  ࡮- 2.0		    */
#endif

char *sqwash_bat = NULL;    /* Pathname to sqwash.bat file		    */
static char tmp[MAXLINE+2]; /* Here is tokenized line from sqwas.bat placed */

FILE	*fileind;	    /* File sqwash.bat opened as text stream	    */
int	i, Wrong_Line = 0;

/* ======================= Command Line help ============================== */
if (argc <= 1)
	{
	puts ("SqWarc V01.03. Addition tool for SqWish V02.15+\n");
	fputs ("Usage: sqwarc @[+|-]flags/sqwash.bat [s [e [compress.cfg ", stdout);
#if TOSSING_LOG
	fputc('[', stdout);
	fputs(tossing_log, stdout);
	fputc(']', stdout);
#endif
	puts ("]]]\nSyntax of lines in sqwash.bat see in sqwarc.bat.");
	puts ("@+ means paranoic calling archivers (no PATH search)");
	exit(1);
	}
else;
/* ========================================================================= */

if (*argv[1] == '@')
   {
   paranoia = (*(argv[1]+1) == '+');
   switch(argc)
     {
     default:
#if TOSSING_LOG
     case 6: tossing_log = argv[5];
#endif
     case 5: compress_cfg = argv[4];
     case 4: Ee[0] = Ee[1] = argv[3];
     case 3: Ss[0] = Ss[1] = argv[2];
     case 2: sqwash_bat = argv[1]+2;
     case 1: sqwarc = argv[0];
     }
   openlog(sqwarc, LOG_PID | LOG_CONS, LOG_USER);
   Read_Compress_Cfg();
   fileind = fopen(sqwash_bat, rt);
   if (fileind)
	{
	while (fgets(tmp,MAXLINE,fileind))
		{
		ClearEOL(tmp);
		argh[0] = strtok(tmp,tabspace); i = 0;
		while  (((argh[++i] = strtok(NULL,tabspace)) != NULL) &&
			(i < MAXARGH));
		if (i < MAXARGH) Line_Analysis(i,argh);
		else Wrong_Line = 1;
		}
	if (ferror(fileind)) goto Main_Error;
	else {
	     fclose(fileind);
	     if (Wrong_Line)
		{
		OutLog4("Wrong line in ", sqwash_bat,empty,empty);
		closelog();
		exit(12);
		}
	     else;
	     }
	} /* if (filein) */
   else {
Main_Error:
	OutLog4(IO_Error, sqwash_bat, empty, empty);
	closelog();
	exit(12);
	}
   } /* if *argv[1] == '@' */
else
   {
   openlog(sqwarc, LOG_PID | LOG_CONS, LOG_USER);
   Read_Compress_Cfg();
   Line_Analysis(argc,argv);
   }
closelog();
exit(0);
} /* main() */

/* EOF sqwarc.c */
